function varargout = ICAofLFPs(varargin)
% ICAOFLFPS M-file for ICAofLFPs.fig
%      ICAOFLFPS, by itself, creates a new ICAOFLFPS or raises the existing
%      singleton*.
%
%      H = ICAOFLFPS returns the handle to a new ICAOFLFPS or the handle to
%      the existing singleton*.
%
%      ICAOFLFPS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ICAOFLFPS.M with the given input arguments.
%
%      ICAOFLFPS('Property','Value',...) creates a new ICAOFLFPS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ICAofLFPs_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ICAofLFPs_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ICAofLFPs

% Last Modified by GUIDE v2.5 01-Jul-2021 20:17:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ICAofLFPs_OpeningFcn, ...
                   'gui_OutputFcn',  @ICAofLFPs_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ICAofLFPs is made visible.
function ICAofLFPs_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ICAofLFPs (see VARARGIN)
global Args LFP Trains G  LFP_CA1 Artfcts GnrsSet mTG Tetrode

% Choose default command line output for ICAofLFPs
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ICAofLFPs wait for user response (see UIRESUME)
% uiwait(handles.figure1);
if ~isdeployed
    HipDIR = fileparts(which('ICAofLFPs'));
    path(HipDIR,path);
    path([HipDIR filesep 'MatFunc'],path);
    path([HipDIR filesep 'Matlab_Interface'],path);
%   id = strfind(HipDIR, filesep);
%   HipDIR = [HipDIR(1:id(end)) 'work'];
%   path(path,[HipDIR filesep 'FastICA_25']);
%   path(path,[HipDIR filesep 'ElectrodeConfigurations']);
%   path(path,[HipDIR filesep 'Tools']);
end

Args = []; LFP = []; Trains = []; G = [];  LFP_CA1 = []; Artfcts = [];
GnrsSet = []; mTG = []; Tetrode = [];
set(handles.figure1,'Name','Analysis of LFPs (ver. 1.09, September 2021)')


% --- Outputs from this function are returned to the command line.
function varargout = ICAofLFPs_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --------------------------------------------------------------------
function Artifacts_Callback(hObject, eventdata, handles)
% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% --------------------------------------------------------------------
function Tools_Callback(hObject, eventdata, handles)
% --------------------------------------------------------------------
function Copy_Callback(hObject, eventdata, handles)
% --------------------------------------------------------------------
function Help_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function OpenMAT_Callback(hObject, eventdata, handles)
global Args LFP Trains G Axis1Flag Artfcts LFP_CA1 GnrsSet Tetrode
persistent fd

if isempty(fd) || isnumeric(fd)
    switch lower(computer)
        case {'maci64','glnxa64','glnx86'}
                fd = '~/Desktop';
        case {'pcwin','pcwin64'}
            fd = fileparts(mfilename('fullpath'));
            fd = fd(1:3);
        otherwise
            disp('unkonwn architecture')
            fd = '';
    end    
end
try 
    cd(fd)
catch me
    disp('The current folder has been reset.')
end
[fn, fd] = uigetfile({'*.smr;*.mat;*.mcd;*.txt;*.asc;*.eeg;*.SMR;*.MAT;*.MCD'}, 'Pick a data file');
if fn == 0, return; end
file = fullfile(fd,fn);
[~,~,Fext] = fileparts(file);
Fext = lower(Fext);
if isempty(strmatch(Fext, {'.smr','.mat','.mcd','.txt','.asc','.eeg'}))
    errordlg('Unknown file extension. Select: smr, mat, txt, or asc file.','warning','modal');
    return;
end
h = msgbox('Open file, don''t press any key, JUST WAIT!','warning','modal');
Args = []; LFP = []; Trains = []; G = []; Artfcts = []; LFP_CA1 = []; 
GnrsSet = []; mTG = []; Tetrode = [];
set(handles.ArangeElectrodes,'Enable','on');
set(handles.CustomArrange,'Enable','on')
switch Fext
    case '.smr'
        [Args, LFP, Trains] = LoadSMRfile(file);
        close(h);
    case '.mcd'
        try
            [Args, LFP, Trains] = LoadMCDfile(file);
        catch me
            msgbox('An error has been occured. Can''t continue');
        end
%         if strcmpi(Args.ChannelArranged,'yes')
%             set(handles.ArangeElectrodes,'Enable','off')
%             set(handles.CustomArrange,'Enable','off')
%         end
        close(h);
    case '.mat'
        clear ExtraResults
        load(file)
        close(h);
        if exist('ExtraResults','var')
            uiwait(msgbox('Simulated data.'))
            Args.Fs = ExtraResults.Fs;
            Args.T0 = 0;
            LFP = ExtraResults.LFP;
        end
        if isempty(LFP)
            errordlg('No LFP signals in the file!','error');
            return;
        end
    case {'.txt','.asc'}
        % read LFPs
        try
            x = load(file)';
        catch ME
            close(h);
            errordlg('Incorrect file format','error');
            return;
        end
        close(h);
        if ~isnumeric(x)
            errordlg('Incorrect file format','error');
            return;
        end
        nch = size(x,1)-1;
        if nch ~= 16 && nch ~= 32
            errordlg('Incorrect data format','error');
            return;
        end
        Args.Fs = 1/diff(x(1,1:2));
        LFP = x(2:end,:);
        Args.T0 = 0;
    case '.eeg'
        close(h);
        answer = inputdlg('Time interval in s (e.g. [0 10])','For Buzz only!',1,{'[0 inf]'});
        if isempty(answer) || isempty(answer{1}), return; end
        [LFP, Args] = ReadEEUUfile(file, str2num(answer{1}));
end

%fid = fopen('~/.filesswitch', 'a');
%fprintf(fid, 'ICAofLFPs: %s,', date);
%fprintf(fid, ' %s\n', file);
%fclose(fid);

[nChs, nPts] = size(LFP);
if nChs*nPts == 0, return; end
if isempty(Trains)
    nTrs = 0;
else
    nTrs = length(Trains.Spikes);
end
if isempty(GnrsSet)
    nGs = 0;
else
    nGs = length(GnrsSet);
    G = GnrsSet{1};
    set(handles.SelectedLoadings,'String',num2str(G.ID));
end
set(handles.StatusTXT,'String',['File: ' file])
set(handles.StatusFs,'String',['Fs = ' num2str(1e-3*Args.Fs,2) ' kHz'])
set(handles.StatusTrains,'String',['Sp. Trains = ' num2str(nTrs)])
set(handles.StatusGeners,'String',['Avail. Geners = ' num2str(nGs)])
set(handles.StatusChannels,'String',['LFP Chans = ' num2str(nChs)])
set(handles.ElectrodeRange,'String',['[1:' num2str(min(32,nChs)) ']']);
% set(handles.EliminatePPartifacts,'Enable','on');
% set(handles.EliminatePPoffset,'Enable','on');
set(handles.Yscale,'String','auto');
Axis1Flag = 'LFPs';

if ~isempty(LFP)
    if any(isnan(LFP(1,:)))
        ButtonName = questdlg(...
            'LFPs have blank time intervals (IN GNENERAL: NEVER USE SUCH DATA, RESULTS MAY BE WRONG!). Remove blank intervals (IT MAY NOT HELP)?', ...
            'PROBLEM WITH DATA', 'Yes', 'No', 'Yes');
        if strcmpi(ButtonName,'Yes')
            id = isnan(LFP(1,:));
            LFP(:,id) = [];
        end
    end
    
    if ~isfield(Args,'VoltDIM') || isempty(Args.VoltDIM) || strcmpi(Args.VoltDIM,'V'),
        Amplitude = mean(std(LFP(:,1:min(10000,size(LFP,2))),1,2));
        if Amplitude < 0.01
            ButtonName = questdlg(...
                'It seems your LFPs are measured in Volts. Do you want to rescale them to mV (recommended)?', ...
                'Voltage Scale', 'Yes', 'No', 'Yes');
            if strcmpi(ButtonName,'Yes')
                LFP = LFP*1e3;
                LFP_CA1 = LFP_CA1*1e3;
                Args.VoltDIM = 'mV';
            else
                Args.VoltDIM = 'V';
            end
        else
            Args.VoltDIM = 'mV';
        end
    end
    
    ShowAll_Callback(hObject, eventdata, handles)
    set(handles.ChannelSelector,'String',num2str((1:nChs)'))
end
if ~isempty(Artfcts) && isfield(Artfcts,'z') && size(Artfcts.z,2) == size(LFP,2)
    set(handles.ICAwindows,'Enable','on')
else
    set(handles.ICAwindows,'Enable','off')
end

if isfield(Args,'ArtfctIDX')
%     set(handles.PPtriggeredICA,'Enable','on')
else
    set(handles.PPtriggeredICA,'Enable','off')
end

% --------------------------------------------------------------------
function Append_Callback(hObject, eventdata, handles)
global Args LFP Trains

if isempty(LFP)
    beep;
    uiwait(errordlg('Append NEW data to already existing! First open a file.','warning','modal'));
    return; 
end
Tstart = Args.T0 + size(LFP,2)/Args.Fs;
Args_Tmp = Args;
LFP_Tmp = LFP;
Trains_Tmp = Trains;
LFP = [];
Args = [];
Trains = [];
OpenMAT_Callback(hObject, eventdata, handles);
if Args.Fs ~= Args_Tmp.Fs || size(LFP_Tmp,1) ~= size(LFP,1)
    beep
    uiwait(errordlg('Incompatible files. Check channel numbers and Fs.','warning','modal'));
    LFP = LFP_Tmp;
    Args = Args_Tmp;
else
    if isfield(Args,'ArtfctIDX')
        if isfield(Args_Tmp,'ArtfctIDX')
            Args_Tmp.ArtfctIDX = [Args_Tmp.ArtfctIDX(:); size(LFP_Tmp,2) + Args.ArtfctIDX(:)]; 
        else
            Args_Tmp.ArtfctIDX = size(LFP_Tmp,2) + Args.ArtfctIDX;
        end
    end
    LFP = [LFP_Tmp LFP];
    Args = Args_Tmp;
    if isempty(Trains)
        Trains = Trains_Tmp;
    elseif isempty(Trains_Tmp)
        for k = 1:size(Trains.Spikes,2)
            Trains.Spikes{k} = Trains.Spikes{k} + Tstart;
        end
    else
        if size(Trains.Spikes,2) == size(Trains_Tmp.Spikes,2)
            for k = 1:size(Trains.Spikes,2)
                Trains.Spikes{k} = [Trains_Tmp.Spikes{k}; Trains.Spikes{k} + Tstart];
            end
        else
            Trains.Titles = num2str([str2num(Trains.Titles); str2num(Trains_Tmp.Titles)]);
            n1 = size(Trains.Spikes,2);
            n2 = size(Trains_Tmp.Spikes,2);
            for k = 1:n1
                Trains.Spikes{k} = Trains.Spikes{k} + Tstart;
            end
            for k = 1:n2
                Trains.Spikes{n1+k} = Trains_Tmp.Spikes{k};
            end
        end
    end
end
ShowAll_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function PlotLFPs_Callback(hObject, eventdata, handles)
global Args LFP Axis1Flag
if isempty(LFP), beep; return; end

if strcmpi(get(handles.PlotWorst,'Checked'),'on')
    PlotPresision = 1;
elseif strcmpi(get(handles.PlotBest,'Checked'),'on')
    PlotPresision = 3;
else
    PlotPresision = 2;
end    

set(handles.wICApanel,'Visible','off')
axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
Chns = intersect((1:size(LFP,1)),str2num(get(handles.ElectrodeRange,'String')));
if isempty(Chns), return; end
if strcmpi(Axis1Flag,'LFPs')
    yscale = str2num(get(handles.Yscale,'String'));
else
    set(handles.Yscale,'String','auto');
    yscale = [];
end
Axis1Flag = 'LFPs';
ChTitle = ['e'*ones(length(Chns),1) num2str(Chns(:))];
ChTitle = mat2cell(ChTitle,ones(size(ChTitle,1),1),size(ChTitle,2));
iLims = round(Args.Fs*Tlim);
iLims(1) = max(iLims(1),1); iLims(2) = min(iLims(2),size(LFP,2));
if iLims(2)<= iLims(1)
    ShowAll_Callback(hObject, eventdata, handles);
    return;
end  
if PlotPresision == 1
    step = ceil(diff(iLims)/1000);
elseif PlotPresision == 2
    step = ceil(diff(iLims)/4000);
else
    step = 1;
end
hold off
PlotEEG(LFP(Chns,iLims(1):step:iLims(2)), Args.Fs/step, ChTitle, yscale,'LFP', (iLims(1)-1)/Args.Fs, 'k',[], Args.VoltDIM)
xlim(iLims/Args.Fs)
PlotStimulusPositions(Args)
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')



% --------------------------------------------------------------------
function PlotSpikeTrains_Callback(hObject, eventdata, handles)
global Args Trains Axis1Flag
if isempty(Trains), beep; return; end


n1 = length(Trains.Spikes);
[n2, n3] = size(Trains.Titles);
if n1 ~= n2 || n3 ~= 2,
    answer = questdlg('Your spike trains have problems. Fixed?',...
        'Problem with trains','yes','no','yes');
    if strcmpi(answer,'yes')
        TrTitles = [];
        for k = 1:n1
            TrTitles = [TrTitles; num2str(k,'%2.2d')];
        end
        Trains.Titles = TrTitles;
        uiwait(msgbox([num2str(n1) ' trains are included.']))
    end
end

set(handles.wICApanel,'Visible','off')
axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
hold off; cla
PlotSpikeTrains(Trains.Spikes, Tlim, Trains.Titles);
PlotStimulusPositions(Args)
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
Axis1Flag = 'Trains';



% --------------------------------------------------------------------
function WTspectrum_Callback(hObject, eventdata, handles)
global Axis1Flag
if isempty(Axis1Flag)
    beep;
    return;
end
[X, chan, ArgsG] = SelectSignal(hObject, eventdata, handles);
if isempty(X), beep; return; end

set(handles.wICApanel,'Visible','off');
axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','off')
axes(handles.axes4); cla; hold off;
set(handles.axes4,'Visible','off')
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2)
eval([get(handles.SetFrequencyBand,'Label') ';'])
CalculateAndPlotWTspectrum(X, ArgsG, Band)
title(['WT spectrum for channel = ' num2str(chan)])
set(handles.axes2,'Visible','on')


% --- Executes on selection change in ChannelSelector.
function ChannelSelector_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function ChannelSelector_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --------------------------------------------------------------------
function Generators_Callback(hObject, eventdata, handles)
% hObject    handle to Generators (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ICAinWindow_Callback(hObject, eventdata, handles)
global Args LFP G LFP_CA1 Axis1Flag  GnrsSet
if isempty(LFP), beep; return; end


xlm = get(handles.axes1,'Xlim');
h = msgbox('ICA of LFPs, don''t press any key, JUST WAIT!');

if strcmpi(get(handles.DefineNDIM, 'Checked'),'on')
    eval([get(handles.DefineNDIM,'Label') ';']);
else
    NDIM = 'auto';
end
str = get(handles.AUTO_Threshold,'Label');
NDIM_THRESHOLD = 0.01*str2double(str(20:end-1));
if strcmpi(get(handles.RUNICA,'Checked'),'on')
    ICA_TYPE = 'runica';
elseif strcmpi(get(handles.ExtendedICA,'Checked'),'on')
    ICA_TYPE = 'e_runica';
elseif strcmpi(get(handles.FASTICA,'Checked'),'on')
    ICA_TYPE = 'fastica';
else
    ICA_TYPE = 'kdica';
end    


tt = round(Args.Fs*(xlm - Args.T0));
if tt(1) < 1, tt(1) = 1; xlm(1) = Args.T0; end
tt(2) = min(tt(2),size(LFP,2));
switch Axis1Flag
    case {'LFPs','CA1_LFPs'}
        if strcmpi(Axis1Flag,'CA1_LFPs')
            SEV = 'LFP_CA1';
            if isempty(LFP_CA1), beep; close(h); return; end
            if any(size(LFP) - size(LFP_CA1))
                close(h); 
                uiwait(errordlg('Error! This version does not support ARTIFACTS.','warning','modal'));
            end
        else
            SEV = 'LFP';
        end
        
        [A, s, idIN] = MAKE_ICA(eval([SEV '(:,tt(1):tt(2))']), 'NDIM', NDIM,...
            'verbose', 'off', 'ica_type', ICA_TYPE, 'ndim_threshold', NDIM_THRESHOLD);
        NDIM = size(A,2);
    otherwise
        close(h)
        errordlg('First: select LFP window for ICA.', 'warning','modal');
        return;
end
set(handles.Status,'String',['Current NDIM = ' num2str(NDIM)]);
G = [];
if isempty(idIN), idIN = [1, 2]; end
G.V = A; G.s = s; G.T0 = xlm(1); G.ID = idIN;
set(handles.SelectedLoadings,'String',num2str(G.ID));
PlotGenerators_Callback(hObject, eventdata, handles);
close(h)
set(handles.StatusGeners,'String',['Avail. Geners = ' num2str(length(GnrsSet)) ' + 1'])



% --- Executes on button press in ShowAll.
function ShowAll_Callback(hObject, eventdata, handles)
global Args LFP G Axis1Flag Artfcts LFP_CA1 Trains mTG LFPttr
if isempty(LFP) && isempty(Trains), beep; return; end

set(handles.wICApanel,'Visible','off')
axes(handles.axes1)
switch Axis1Flag
    case 'LFPs'
        set(handles.axes1,'Xlim',Args.T0 + [0 size(LFP,2)/Args.Fs]);
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        set(handles.axes1,'Xlim',Args.T0 + [0 size(LFP_CA1,2)/Args.Fs]);
        PlotCA1LFPs_Callback(hObject, eventdata, handles);
    case 'G'
        if ~isfield(G,'s'), return; end
        set(handles.axes1,'Xlim',G.T0 + [0 size(G.s,2)/Args.Fs]);
        PlotGenerators_Callback(hObject, eventdata, handles);
    case 'Artifacts'
        if ~isfield(Artfcts, 'z'), return; end
        set(handles.axes1,'Xlim',Artfcts.T0 + [0 size(Artfcts.z,2)/Args.Fs]);
        PlotArtifacts_Callback(hObject, eventdata, handles);
    case 'Trains'
        if isempty(Trains), return; end
        tend = 0;
        for k = 1:length(Trains.Spikes),
            if ~isempty(Trains.Spikes{k}),
                tend = max(tend,Trains.Spikes{k}(end));
            end
        end
        if tend == 0,
            tend = size(LFP,2)/Args.Fs;
        end
        set(handles.axes1,'Xlim',[0 tend]);
        PlotSpikeTrains_Callback(hObject, eventdata, handles);
    case 'mTG'
        if isempty(mTG), return; end
        set(handles.axes1,'Xlim',mTG.T0 + [0 (size(mTG.data,2)-1)/Args.Fs]);
        PlotMeanTriggeredICs_Callback(hObject, eventdata, handles)
    case 'Tetrode'
        if isempty(LFPttr), return; end
        set(handles.axes1,'Xlim',Args.T0 + [0 size(LFP,2)/Args.Fs]);
        PlotTetrode_Callback(hObject, eventdata, handles)
end


% --- Executes on button press in XLims.
function XLims_Callback(hObject, eventdata, handles)
global LFP Args Axis1Flag Trains
if isempty(LFP) && isempty(Trains), beep; return; end

axes(handles.axes1)
ylm = get(handles.axes1,'Ylim');
[x1,yi,but] = ginput(1);
hold on
plot([x1 x1],ylm,'color',[0.8,0.6,0.6],'LineWidth',2);
[x2,yi,but] = ginput(1);
xlm = sort([x1 x2]);
switch Axis1Flag
    case 'Trains'
    otherwise
        if xlm(1) < Args.T0, xlm(1) = Args.T0; end
        if xlm(2) > Args.T0 + size(LFP,2)/Args.Fs, xlm(2) = Args.T0 + size(LFP,2)/Args.Fs; end
end
xlim(xlm);
switch Axis1Flag
    case 'LFPs'
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        PlotCA1LFPs_Callback(hObject, eventdata, handles);
    case 'G'
        PlotGenerators_Callback(hObject, eventdata, handles)
    case 'mTG'
        PlotMeanTriggeredICs_Callback(hObject, eventdata, handles)
    case 'Tetrode'
        PlotTetrode_Callback(hObject, eventdata, handles)
    case 'Trains'
        PlotSpikeTrains_Callback(hObject, eventdata, handles)
end

% --- Executes on button press in XLimsx2.
function XLimsx2_Callback(hObject, eventdata, handles)
global LFP Args Axis1Flag Trains
if isempty(LFP) && isempty(Trains), beep; return; end

axes(handles.axes1)
xlm = get(handles.axes1,'Xlim');
xlm = 0.5*sum(xlm) + diff(xlm)*[-1 1]; % new limits
if ~strcmpi(Axis1Flag,'Trains')
    if xlm(1) < Args.T0, xlm(1) = Args.T0; end
    xmax = Args.T0 + size(LFP,2)/Args.Fs;
    if xlm(2) > xmax, xlm(2) = xmax; end
end
xlim(xlm)
switch Axis1Flag
    case 'LFPs'
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        PlotCA1LFPs_Callback(hObject, eventdata, handles);
    case 'G'
        PlotGenerators_Callback(hObject, eventdata, handles)
    case 'mTG'
        ShowAll_Callback(hObject, eventdata, handles)
    case 'Tetrode'
        PlotTetrode_Callback(hObject, eventdata, handles)
    case 'Trains'
        PlotSpikeTrains_Callback(hObject, eventdata, handles)
end
    

% --- Executes on button press in MoveRight.
function MoveRight_Callback(hObject, eventdata, handles)
global LFP Args Axis1Flag Trains
if isempty(LFP) && isempty(Trains), beep; return; end

axes(handles.axes1)
xlm = get(handles.axes1,'Xlim');
xlm = xlm + 0.2*diff(xlm); % new limits
if ~strcmpi(Axis1Flag,'Trains')
    if xlm(1) < Args.T0, xlm(1) = Args.T0; end
    xmax = Args.T0 + size(LFP,2)/Args.Fs;
    if xlm(2) > xmax, xlm(2) = xmax; end
end
xlim(xlm)
switch Axis1Flag
    case 'LFPs'
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        PlotCA1LFPs_Callback(hObject, eventdata, handles);
    case 'G'
        PlotGenerators_Callback(hObject, eventdata, handles)
    case 'mTG'
        ShowAll_Callback(hObject, eventdata, handles)
    case 'Tetrode'
        PlotTetrode_Callback(hObject, eventdata, handles)
    case 'Trains'
        PlotSpikeTrains_Callback(hObject, eventdata, handles)
end
 

% --- Executes on button press in MoveLeft.
function MoveLeft_Callback(hObject, eventdata, handles)
global LFP Args Axis1Flag Trains
if isempty(LFP) && isempty(Trains), beep; return; end

axes(handles.axes1)
xlm = get(handles.axes1,'Xlim');
xlm = xlm - 0.2*diff(xlm); % new limits
if ~strcmpi(Axis1Flag,'Trains')
    if xlm(1) < Args.T0, xlm(1) = Args.T0; end
    xmax = Args.T0 + size(LFP,2)/Args.Fs;
    if xlm(2) > xmax, xlm(2) = xmax; end
end
xlim(xlm)
switch Axis1Flag
    case 'LFPs'
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        PlotCA1LFPs_Callback(hObject, eventdata, handles);
    case 'G'
        PlotGenerators_Callback(hObject, eventdata, handles)
    case 'mTG'
        ShowAll_Callback(hObject, eventdata, handles)
    case 'Tetrode'
        PlotTetrode_Callback(hObject, eventdata, handles)
    case 'Trains'
        PlotSpikeTrains_Callback(hObject, eventdata, handles)
end
 


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
msg = [get(handles.figure1,'Name') ' by V. Makarov: vmakarov@ucm.es'];
helpdlg(msg,'About');

% --------------------------------------------------------------------
function ProductHelp_Callback(hObject, eventdata, handles)
beep;
errordlg('The help is outdated')
%web('ICAofLFPhelp.htm')


% --------------------------------------------------------------------
function HelpSpikeSorting_Callback(hObject, eventdata, handles)
M = computer; M = M(1:3);
switch M
    case 'MAC'
        if exist('HelpICASortSpikes.pdf','file')
            open('HelpICASortSpikes.pdf')
        else
            errordlg('Can''t find the file with help')
        end
    case 'GLN'
        if exist('/opt/ICA/HelpICASortSpikes.pdf','file')
            unix('epdfview /opt/ICA/HelpICASortSpikes.pdf')
        else
            errordlg('Can''t find the file with help')
        end
    otherwise
            errordlg('Unknown platform.')        
end


% --------------------------------------------------------------------
function CopyMETA_Callback(hObject, eventdata, handles)
set(gcf,'PaperPositionMode','auto')
if strcmpi(computer,'pcwin')
    print -dmeta -noui
else
    msgbox('This works on windows only')
end
% --------------------------------------------------------------------
function CopyBMP_Callback(hObject, eventdata, handles)
if strcmpi(computer,'pcwin')
    print -dbitmap
else
    msgbox('This works on windows only')
end
% --------------------------------------------------------------------
function SaveEPS_Callback(hObject, eventdata, handles)

[fn, fd] = uiputfile('untitled.eps', 'Save file name');
if fn == 0, beep; return; end
file = fullfile(fd,fn);
set(gcf,'PaperPositionMode','auto')
print(file,'-depsc2','-noui');

% --------------------------------------------------------------------
function SavePNG_Callback(hObject, eventdata, handles)
[fn, fd] = uiputfile('untitled.png', 'Save file name');
if fn == 0, beep; return; end
file = fullfile(fd,fn);
set(gcf,'PaperPositionMode','auto')
print(file,'-dpng','-r200')



% --------------------------------------------------------------------
function PlotGenerators_Callback(hObject, eventdata, handles)
global Args G Axis1Flag GnrsSet
if isempty(G), beep; return; end


if ~any(strcmpi(Axis1Flag,{'G','mGT'}))
    set(handles.SelectedLoadings,'String', num2str(G.ID,'%d '));
    set(handles.LoadingsGroup,'Title','Loadings');
    set(handles.Yscale,'String','auto');
    yscale = [];
else
    yscale = str2num(get(handles.Yscale,'String'));
end
idIN = str2num(get(handles.SelectedLoadings,'String'));
idIN = intersect(1:size(G.s,1),idIN);
if isempty(idIN)
    uiwait(errordlg('No such generators.','warning','modal'))
    return;
end
set(handles.SelectedLoadings,'String',num2str(idIN));

set(handles.wICApanel,'Visible','off')
nGs = length(GnrsSet);
if nGs > 0,
    set(handles.GeneratorSet,'String',num2str((1:nGs)'));
else
    set(handles.GeneratorSet,'String',' ');
end
set(handles.GeneratorGroup,'Visible','on');
axes(handles.axes2)
set(handles.axes2,'Visible','off')
cla
set(handles.ChannelGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','on')
if strcmpi(get(handles.PlotWorst,'Checked'),'on')
    PlotPresision = 1;
elseif strcmpi(get(handles.PlotBest,'Checked'),'on')
    PlotPresision = 3;
else
    PlotPresision = 2;
end    
G.ID = idIN;
axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
ArgsG = Args;
ArgsG.T0 = G.T0;
hold off; cla;
mark = repmat('bgrcmyk',1,10);
mark = mark(idIN);
GenTitles = ['s'*ones(length(idIN),1) num2str(idIN(:))];
GenTitles = mat2cell(GenTitles,ones(1,size(GenTitles,1)),size(GenTitles,2));
PlotLFPTraces(G.s(idIN,:), ArgsG, Tlim(1), diff(Tlim),...
    'generator activations', GenTitles, mark, yscale, PlotPresision);
PlotStimulusPositions(Args)
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')

nElc = str2num((get(handles.ElectrodeRange,'String')));
nElc = [min(nElc) max(nElc)];

axes(handles.axes3)
hold off; cla;
PlotLoadings(G.V, [], idIN,[],nElc)
title('voltage loadings')
set(handles.axes3,'Visible','on')

% I = -SecondDerivative(G.V,'double2');
if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
I = -Derivative_1D(G.V, Type2deriv);
axes(handles.axes4)
hold off; cla;
PlotLoadings(I,[],idIN,[],nElc)
title('CSD loadings')
set(handles.axes4,'Visible','on')
Axis1Flag = 'G';


% --------------------------------------------------------------------
function Plot2ndGenerator_Callback(hObject, eventdata, handles)
global LFP Args G Axis1Flag GnrsSet
if isempty(G), beep; return; end

Tlim = get(handles.axes1,'Xlim');
PlotLFPs_TwoGenerators(LFP, GnrsSet, Args.Fs, Tlim)


function SelectedLoadings_Callback(hObject, eventdata, handles)
UpdateLoadings_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function SelectedLoadings_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in UpdateLoadings.
function UpdateLoadings_Callback(hObject, eventdata, handles)
global Axis1Flag

if get(handles.axes2,'Visible')
    Plot2ndGenerator_Callback(hObject, eventdata, handles);
else
    switch Axis1Flag
        case 'G'
            PlotGenerators_Callback(hObject, eventdata, handles);
        case 'Artifacts'
            DefineCA1_Callback(hObject, eventdata, handles);
        case 'mTG'
            PlotMeanTriggeredICs_Callback(hObject, eventdata, handles)
    end
end

% --------------------------------------------------------------------
function SaveAs_Callback(hObject, eventdata, handles)
global Args LFP Trains G Artfcts LFP_CA1 GnrsSet mTG
if isempty(LFP), beep; return; end 

if isfield(Args,'FDIR')
    [fn, fd] = uiputfile(fullfile(Args.FDIR,[Args.FILE(1:end-4) '.mat']), 'Save results');
else
    [fn, fd] = uiputfile('untitled.mat', 'Save results');
end
if isnumeric(fn), return; end
file = fullfile(fd,fn);
try
    S= whos('LFP');
    if S.bytes/1024/1024/1024 > 1.7
        h = msgbox('Saving data, JUST WAIT! 64 bit format is used!');
        save(file,'LFP','Args','G','Trains','GnrsSet',...
            'Artfcts','LFP_CA1','mTG','-v7.3');
    else
        h = msgbox('Saving data, don''t press any key, JUST WAIT!');
        save(file,'LFP','Args','G','Trains','GnrsSet',...
            'Artfcts','LFP_CA1','mTG');
    end
catch me
    close(h)
    errordlg(['Cannot write to ' fn '; Check permissions.'],'warning','modal');
    return
end
close(h)
set(handles.StatusTXT,'String',['File: ' file ' saved'])


% --------------------------------------------------------------------
function DefineCA1_Callback(hObject, eventdata, handles)
global Args LFP Artfcts G Axis1Flag
if isempty(LFP), return; end 
if isempty(G), 
    errordlg('First make preliminar ICA.', 'warning','modal');
    return;
end

if ~strcmpi(Axis1Flag,'Artifacts')
    set(handles.SelectedLoadings,'String',['[1,' num2str(size(G.V,2)) ']']);
    set(handles.LoadingsGroup,'Title','Electrodes');
end

xlm = get(handles.axes1,'Xlim');
tt = round(Args.Fs*(xlm - Args.T0));
if tt(1) < 1, tt(1) = 1; xlm(1) = Args.T0; end
tt(2) = min(tt(2),size(LFP,2));
Electrodes = str2num(get(handles.SelectedLoadings,'String'));

[U, z] = DetectArtifactsInCA1(LFP(:,tt(1):tt(2)), 'bvu', Electrodes);
Artfcts = [];
Artfcts.U = U; Artfcts.z = z; Artfcts.CA1 = Electrodes;
Artfcts.T0 = xlm(1);
Artfcts.t1 = tt(1);
Axis1Flag = 'Artifacts';
PlotArtifacts_Callback(hObject, eventdata, handles)
set(handles.LoadingsGroup,'Visible','on')

% --------------------------------------------------------------------
function PlotArtifacts_Callback(hObject, eventdata, handles)
global Args Artfcts Axis1Flag
if isempty(Artfcts), beep; return; end

if ~strcmpi(Axis1Flag,'Artifacts')
    set(handles.SelectedLoadings,'String', ['[' num2str(Artfcts.CA1) ']']);
    set(handles.LoadingsGroup,'Title','Electrodes');
end
axes(handles.axes2)
set(handles.axes2,'Visible','off')
cla
set(handles.ChannelGroup,'Visible','off')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','on')

axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
ArgsG = Args;
ArgsG.T0 = Artfcts.T0;
hold off; cla;
mark = 'bgrcmykbgrcmykbgrcmykbgrcmykbgrcmykbgrcmyk';
PlotLFPTraces(Artfcts.z, ArgsG, Tlim(1), diff(Tlim),...
    'artifact activations: A1 (blue) - bottom, A2 (green) - top, A3 (red) - volume','A', mark);
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')

axes(handles.axes3)
hold off; cla;
PlotLoadings(Artfcts.U)
ylm = get(handles.axes3,'Ylim');
hold on; plot(Artfcts.CA1(1)*[1 1],ylm,'k--', Artfcts.CA1(2)*[1 1],ylm,'k--')
title('voltage loadings (artifacts)')
set(handles.axes3,'Visible','on')

if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
I = -Derivative_1D(Artfcts.U, Type2deriv);
axes(handles.axes4)
hold off; cla;
PlotLoadings(I)
ylm = get(handles.axes4,'Ylim');
hold on; plot(Artfcts.CA1(1)*[1 1],ylm,'k--', Artfcts.CA1(2)*[1 1],ylm,'k--')
title('CSD loadings (artifacts)')
set(handles.axes4,'Visible','on')
Axis1Flag = 'Artifacts';
set(handles.LoadingsGroup,'Visible','off')


% --------------------------------------------------------------------
function PlotICvariance_Callback(hObject, eventdata, handles)
global G Axis1Flag
if isempty(G), beep; return; end

set(handles.LoadingsGroup,'Visible','off')
set(handles.ChannelGroup,'Visible','off')

%I0 = -SecondDerivative(G.V, 'double2');
if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
I0 = -Derivative_1D(G.V, Type2deriv);

sVar = mean(G.s.^2,2)';
C = sum(G.V.^2).*sVar;
Vvar = C/sum(C);
C = sum(I0.^2).*sVar;
Ivar = C/sum(C);

axes(handles.axes3)
hold off; cla;
bar(Vvar,'b')
title('voltage variance')
set(handles.axes3,'Visible','on')

axes(handles.axes4)
hold off; cla;
bar(Ivar,'b')
title('current variance')
set(handles.axes4,'Visible','on')

% --------------------------------------------------------------------
function CleanLFPs_Callback(hObject, eventdata, handles)
% hObject    handle to CleanLFPs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Args LFP Artfcts G Axis1Flag LFP_CA1
if isempty(LFP) || isempty(Artfcts), return; end 

PlotLFPs_Callback(hObject, eventdata, handles)
set(handles.LoadingsGroup,'Visible','off')

CA1 = Artfcts.CA1;

axes(handles.axes3)
hold off; cla;
set(handles.axes3,'Visible','off')
axes(handles.axes4)
hold off; cla;
set(handles.axes4,'Visible','off')

axes(handles.axes2)
hold off; cla;
set(handles.axes2,'Visible','on')
Tlim = get(handles.axes1,'Xlim');
LFP_CA1 = LFP(CA1(1):CA1(2),Artfcts.t1+[0:size(Artfcts.z,2)-1]) - Artfcts.U(CA1(1):CA1(2),:)*Artfcts.z;
ArgsG = Args;
ArgsG.T0 = Artfcts.T0;
PlotLFPTraces(LFP_CA1, ArgsG, Tlim(1), diff(Tlim),'cleaned LFPs in CA1');


% --------------------------------------------------------------------
function PlotCA1LFPs_Callback(hObject, eventdata, handles)
global Args Axis1Flag LFP_CA1
if isempty(LFP_CA1), beep; return; end 

set(handles.wICApanel,'Visible','off')
axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
Chns = str2num(get(handles.ElectrodeRange,'String'));
if ~isfield(Args,'CA1')
    errordlg('No Virtual LFP defined.','warning','modal');
    return; 
end
 
[Chns,idChns] = intersect(Args.CA1,Chns);
if isempty(Chns) 
    errordlg('No Virtual LFP channels to show! Check selected channels.','warning','modal');
    return; 
end
if strcmpi(Axis1Flag,'CA1_LFPs')
    yscale = str2num(get(handles.Yscale,'String'));
else
    set(handles.Yscale,'String','auto');
    yscale = [];
end
ChTitle = ['e'*ones(length(Chns),1) num2str(Chns(:))];
ChTitle = mat2cell(ChTitle,ones(size(ChTitle,1),1),size(ChTitle,2));
PlotLFPTraces(LFP_CA1(idChns,:), Args, Tlim(1), diff(Tlim),'Virtual LFPs',ChTitle,[],yscale, Args.VoltDIM);
PlotStimulusPositions(Args)
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
Axis1Flag = 'CA1_LFPs';


% --------------------------------------------------------------------
function Spikes_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function SaveGenerators_Callback(hObject, eventdata, handles)
global Args Axis1Flag LFP_CA1 Artfcts G GnrsSet
if isempty(G), return; end

nGs = length(GnrsSet);
GnrsSet{nGs+1} = G;
set(handles.GeneratorSet,'String',num2str((1:nGs+1)'));
set(handles.StatusGeners,'String',['Avail. Geners = ' num2str(nGs+1)])





% --- Executes on selection change in GeneratorSet.
function GeneratorSet_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function GeneratorSet_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in UdateGenrSet.
function UdateGenrSet_Callback(hObject, eventdata, handles)
% hObject    handle to UdateGenrSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global  G GnrsSet
if isempty(GnrsSet), return; end

nGs = get(handles.GeneratorSet,'Value');
G = GnrsSet{nGs};
if get(handles.axes2,'Visible')
    Plot2ndGenerator_Callback(hObject, eventdata, handles);
else
    PlotGenerators_Callback(hObject, eventdata, handles);
end


% --------------------------------------------------------------------
function DeleteGenerators_Callback(hObject, eventdata, handles)
% hObject    handle to DeleteGenerators (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global  G GnrsSet
if isempty(GnrsSet), return; end

answer=inputdlg({['Generator set to delete (from 1 to ' num2str(length(GnrsSet)) ', e.g., [1:3]):']},...
    'Delete Generator Sets',1,{'1'});
if isempty(answer), return; end
nDel = str2num(answer{1}); nDel = intersect(nDel, 1:numel(GnrsSet));
GnrsSet(nDel) = [];
nGs = length(GnrsSet);
if nGs > 0
    G = GnrsSet{1};
    set(handles.GeneratorSet,'String',num2str((1:nGs)'));
    set(handles.GeneratorSet,'Value',1);
    PlotGenerators_Callback(hObject, eventdata, handles);
else
    PlotLFPs_Callback(hObject, eventdata, handles);
end
set(handles.StatusGeners,'String',['Avail. Geners = ' num2str(nGs)])


% --------------------------------------------------------------------
function CompareLFPs_Callback(hObject, eventdata, handles)
% hObject    handle to CompareLFPs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Args Axis1Flag LFP LFP_CA1 Artfcts
if isempty(LFP) || isempty(LFP_CA1), return; end 

chan = intersect(1:size(LFP,1),str2num(get(handles.ElectrodeRange,'String')));
if isempty(chan), 
    errordlg('Wrong channels selected.','warning','modal');
    return;
end
[ch_CA1, id_CA1] = intersect(Args.CA1,chan);
if isempty(ch_CA1), 
    errordlg('No such channels in CA1.','warning','modal');
    retunr; 
end
yscale = str2num(get(handles.Yscale,'String'));
set(handles.ChannelGroup,'Visible','on');
set(handles.GeneratorGroup,'Visible','off')
axes(handles.axes3); cla; set(handles.axes3,'Visible','off');
axes(handles.axes4); cla; set(handles.axes4,'Visible','off');
axes(handles.axes2); cla; hold off; set(handles.axes2,'Visible','on')
xlm = get(handles.axes1,'Xlim');
tt = round(xlm*Args.Fs);
tt(1) = max(1,tt(1));
tt(2) = min(size(LFP,2),tt(2));
if isempty(yscale), yscale = max(max(abs(LFP(chan,tt(1):tt(2))))); end
PlotEEG(LFP(chan,tt(1):tt(2)), Args.Fs, [], yscale, [], xlm(1), 'k')
hold on
chttl = num2str(chan(:));
chttl = mat2cell(chttl, ones(1,size(chttl,1)), size(chttl,2));
PlotEEG(LFP_CA1(id_CA1,tt(1):tt(2)), Args.Fs, ...
    chttl, yscale, 'LFP - black; CA1 LFP - red', xlm(1), 'r')
xlim(xlm)



% --------------------------------------------------------------------
function Exit_Callback(hObject, eventdata, handles)
close(ancestor(hObject,'figure'))


% --------------------------------------------------------------------
function CleanAll_Callback(hObject, eventdata, handles)
global Args LFP Artfcts G Axis1Flag LFP_CA1
if isempty(LFP), return; end 

[nChs, nPts] = size(LFP);
if ~isempty(Artfcts)
    CA1 = Artfcts.CA1;
else
    CA1 = [1,nChs];
end
answer=inputdlg({'CA1 region (e.g., [1,9])','Time segment length (s)'},...
    'Complete Cleaning of LFPs',1,{['[' num2str(CA1(1)) ',' num2str(CA1(2)) ']'], '10'});
if isempty(answer), return; end

CA1 = str2num(answer{1});
dT =  round(Args.Fs*str2num(answer{2}));
nSegs = ceil(nPts/dT);
dT = ceil(nPts/nSegs); % best division into segments

LFP_CA1 = zeros(CA1(2)-CA1(1) + 1, nPts);
Artfcts = [];
Artfcts.z = zeros(3, nPts);
Usegm = zeros(nChs, 3, nSegs);
for k = 1:nSegs,
    tt = [1,dT] + (k-1)*dT;
    tt(2) = min(nPts,tt(2));
    [U, z] = DetectArtifactsInCA1(LFP(:,tt(1):tt(2)), 'bvu', CA1);
    LFP_CA1(:,tt(1):tt(2)) = LFP(CA1(1):CA1(2), tt(1):tt(2)) - U(CA1(1):CA1(2),:)*z;
    Artfcts.z(:,tt(1):tt(2)) = z;
    Usegm(:,:,k) = U;
end    
Artfcts.U = mean(Usegm,3); 
Artfcts.Usegm = Usegm; 
Artfcts.CA1 = CA1;
Artfcts.T0 = Args.T0;
Artfcts.t1 = 1;
Axis1Flag = 'Artifacts';
Ustd = std(Usegm,0,3); %/sqrt(nSegs);
axes(handles.axes1)
xlim(Args.T0 + [0,nPts-1]/Args.Fs); 
PlotArtifacts_Callback(hObject, eventdata, handles);
axes(handles.axes2);
hold off; cla;
set(handles.axes2,'Visible','off')
axes(handles.axes4);
hold off; cla;
set(handles.axes4,'Visible','off')
axes(handles.axes3);
hold off; cla;
set(handles.axes3,'Visible','on')
errorbar(Artfcts.U,Ustd,':')
hold on
PlotLoadings(Artfcts.U)
hold on
ylm = get(handles.axes3,'YLim');
plot(CA1(1)*[1 1], ylm, 'k--',CA1(2)*[1 1], ylm, 'k--'); hold off
title(['Artifact voltage loadings with STD error bar (over ' num2str(nSegs) ' segments)'])
set(handles.ICAwindows,'Enable','on')
set(handles.LoadingsGroup,'Visible','off')

% --------------------------------------------------------------------
function ICAwindows_Callback(hObject, eventdata, handles)
% hObject    handle to ICAwindows (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Args LFP Artfcts G Axis1Flag LFP_CA1 GnrsSet
if isempty(LFP), return; end 
if isempty(LFP_CA1) || size(LFP_CA1,2) ~= size(LFP,2),
    errordlg('First clean LFPs completely.', 'Error');
    return;
end
answer=inputdlg({'Time segment length for ICA (s)'},'Complete ICA of CA1 LFPs',1,{'10'});
if isempty(answer), return; end
[nChs, nPts] = size(LFP_CA1);
dT = round(str2num(answer{1})*Args.Fs);
nSegs = ceil(nPts/dT); % number of segments
dT = ceil(nPts/nSegs); % best division into segments

h = waitbar(0,'Windowed ICA, Please wait...');
for k = 1:nSegs,
    tt = [1,dT] + (k-1)*dT;
    tt(2) = min(nPts,tt(2));
    NDIM = rank(LFP_CA1(:,tt(1):tt(2)));
    [A, s, niters, idIN] = ICA_1(LFP_CA1(:,tt(1):tt(2)), NDIM, 'off');
    G = [];
    G.V = A; G.s = s; G.T0 = Args.T0 + (tt(1)-1)/Args.Fs; G.ID = idIN;
    nGs = length(GnrsSet);
    GnrsSet{nGs+1} = G;
    waitbar(k/nSegs,h)
end
close(h)
nGs = length(GnrsSet);
set(handles.GeneratorSet,'String',num2str((1:nGs)'));
set(handles.GeneratorSet,'Value',nGs);
axes(handles.axes1);
hold off; cla;
xlim(Args.T0 + [0,nPts-1]/Args.Fs); 
PlotGenerators_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function DefineCA1_NoArtifacts_Callback(hObject, eventdata, handles)
global Args LFP Artfcts LFP_CA1
if isempty(LFP), return; end 

[nChs, nPts] = size(LFP);
answer=inputdlg({'CA1 region (e.g., [1:9])'},...
    'Define CA1 LFPs',1,{['[1:' num2str(nChs) ']']});
if isempty(answer), return; end

CA1 = intersect(1:nChs,str2num(answer{1}));
if isempty(CA1),
    errordlg('Wrong channels selected.','warning','modal');
    return;
end
LFP_CA1 = LFP(CA1, :);
Artfcts.T0 = Args.T0;
Args.CA1 = CA1;

PlotCA1LFPs_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function DetrendLFPs_Callback(hObject, eventdata, handles)
global Args LFP G Axis1Flag LFP_CA1
if isempty(LFP), return; end 
Tlim = round(Args.Fs*get(handles.axes1,'Xlim'));

switch Axis1Flag
    case 'LFPs'
        [nChs, nPts] = size(LFP);
        Chs = inputdlg({['Channels to detrend [1:' num2str(nChs) '] (e.g. [1,3:5])']},'detrending',1);
        if isempty(Chs) || isempty(Chs{1}), return; end
        Chns = intersect(str2num(Chs{1}),1:nChs);
        if isempty(Chns), return; end
        id1 = max(Tlim(1),1); 
        id2 = min(Tlim(2), nPts);
        mLFP = mean(LFP(Chns,id1:id2),2);
        LFP(Chns,:) = LFP(Chns,:) - mLFP*ones(1,nPts);
        Args.meanLFP = mLFP;
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        [nChs, nPts] = size(LFP_CA1);
        Chs = inputdlg({['Channels to detrend [1:' num2str(nChs) '] (e.g. [1,3:5])']},'detrending',1);
        if isempty(Chs) || isempty(Chs{1}), return; end
        Chns = intersect(str2num(Chs{1}),1:nChs);
        if isempty(Chns), return; end
        id1 = max(Tlim(1),1); 
        id2 = min(Tlim(2), nPts);
        mLFP = mean(LFP_CA1(Chns,id1:id2),2);
        LFP_CA1(Chns,:) = LFP_CA1(Chns,:) - mLFP*ones(1,nPts);
        PlotCA1LFPs_Callback(hObject, eventdata, handles)
    case 'G'
        [nChs, nPts] = size(G.s);
        Chs = inputdlg({['Channels to detrend [1:' num2str(nChs) '] (e.g. [1,3:5])']},'detrending',1);
        if isempty(Chs) || isempty(Chs{1}), return; end
        Chns = intersect(str2num(Chs{1}),1:nChs);
        if isempty(Chns), return; end
        id1 = max(Tlim(1) - round(G.T0*Args.Fs),1); 
        id2 = min(Tlim(2) - round(G.T0*Args.Fs), nPts);
        mG = mean(G.s(Chns,id1:id2),2);
        G.s(Chns,:) = G.s(Chns,:) - mG*ones(1, nPts);
        PlotGenerators_Callback(hObject, eventdata, handles);
end
uiwait(msgbox(['DC has been subtracted from channels: [' num2str(Chns) ']']));


% --------------------------------------------------------------------
function AddGaussianNoiseToLFP_Callback(hObject, eventdata, handles)
global Args LFP Axis1Flag G LFP_CA1
if isempty(LFP), return; end
answer = inputdlg({'Desired Signal To Noise Ratio'},'mixing noise',1,{'20'});
if isempty(answer), return; end
SNR = str2num(answer{1});
switch Axis1Flag
    case 'LFPs'
        RMS_LFP = sqrt(mean(mean(LFP.^2,2)));
        sig = RMS_LFP/10^(SNR/20);
        LFP = LFP + sig*randn(size(LFP));
        Args.ExtraNoise_dB = SNR;
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        RMS_LFP = sqrt(mean(mean(LFP_CA1.^2,2)));
        sig = RMS_LFP/10^(SNR/20);
        LFP_CA1 = LFP_CA1 + sig*randn(size(LFP_CA1));
        PlotCA1LFPs_Callback(hObject, eventdata, handles);
    case 'G'
        RMS_LFP = sqrt(mean(mean(G.s.^2,2)));
        sig = RMS_LFP/10^(SNR/20);
        G.s = G.s + sig*randn(size(G.s));
        PlotGenerators_Callback(hObject, eventdata, handles);
end


function ElectrodeRange_Callback(hObject, eventdata, handles)
global Axis1Flag
switch Axis1Flag
    case 'LFPs'
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        PlotCA1LFPs_Callback(hObject, eventdata, handles)
    case 'LFPsCSD'
        PlotCSDforLFPs_Callback(hObject, eventdata, handles)
    case 'mTLFPs'
        PlotMeanTriggeredLFPs_Callback(hObject, eventdata, handles)
end        

% --- Executes during object creation, after setting all properties.
function ElectrodeRange_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ElectrodeRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
% --------------------------------------------------------------------
function PlotCSDforLFPs_Callback(hObject, eventdata, handles)
global Args LFP LFP_CA1 Axis1Flag CSD2save
persistent DefAnsw
if isempty(LFP), return; end

if strcmpi(get(handles.PlotWorst,'Checked'),'on')
    PlotPresision = 1;
elseif strcmpi(get(handles.PlotBest,'Checked'),'on')
    PlotPresision = 3;
else
    PlotPresision = 2;
end    


if isempty(DefAnsw)
    DefAnsw{1} = 'auto';
    DefAnsw{2} = '20';
    DefAnsw{3} = 'no';
end    
DefAnsw = inputdlg({'Color max limit (e.g. 2e-3 or auto):','Color gradations (# colors + 1):','Grid (yes/no):'},...
    'Define CSD parameters',1,DefAnsw);
if isempty(DefAnsw), return; end

axes(handles.axes1)
cla; hold off
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')

Chns = str2num(get(handles.ElectrodeRange,'String'));
if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
if strcmpi(Axis1Flag,'CA1_LFPs'),
    [Chns,idChns] = intersect(Args.CA1,Chns);
    CSD2save = ComputeAndDrawCSD(DefAnsw, Args.Fs, Args.T0, [Chns; idChns], LFP_CA1, [], Type2deriv, PlotPresision);
    title('raw CSD of CA1 LFPs')
    Axis1Flag = 'CA1_LFPsCSD';
else
    Chns = intersect(1:size(LFP,1),Chns);
    CSD2save = ComputeAndDrawCSD(DefAnsw, Args.Fs, Args.T0, Chns, LFP, [], Type2deriv, PlotPresision);
    title('raw CSD of LFPs')
    Axis1Flag = 'LFPsCSD';
end
PlotStimulusPositions(Args)

% --------------------------------------------------------------------
function CSDforGenerators_Callback(hObject, eventdata, handles)
global Args G Axis1Flag
persistent DefAnsw
if isempty(G), 
    errordlg('There are no available generators.', 'Error');
    return; 
end
Chns = intersect((1:size(G.V,1)),str2num(get(handles.ElectrodeRange,'String')));
if length(Chns) < 2,
    errordlg('Not enough channels for CSD! Check selected channels.','warning','modal');
    return;
end
if isempty(DefAnsw)
    DefAnsw{1} = '1';
    DefAnsw{2} = 'auto';
    DefAnsw{3} = '20';
    DefAnsw{4} = 'no';
    DefAnsw{5} = 'no';
end    
DefAnsw = inputdlg({'Generator numbers (e.g. [1,2]):','Color max limit (e.g. 2e-3 or auto):',...
    'Color gradations:','Subtract median (yes/no):','Show grid (yes/no)'},...
    'Define CSD parameters',1,DefAnsw);
if isempty(DefAnsw), return; end

axes(handles.axes1)
cla; hold off
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
ComputeAndDrawCSD(DefAnsw, Args.Fs, G.T0, Chns, G.s, G.V, Type2deriv);
PlotStimulusPositions(Args)
title(['CSD for G: ' DefAnsw{1}])
Axis1Flag = 'G_CSD';

% --------------------------------------------------------------------
function MultipleCSDforGenerators_Callback(hObject, eventdata, handles)
global Args G Axis1Flag
persistent DefAnsw
if isempty(G), 
    errordlg('There are no available generators.', 'Error');
    return; 
end
Chns = intersect((1:size(G.V,1)),str2num(get(handles.ElectrodeRange,'String')));
if length(Chns) < 2,
    errordlg('Not enough channels for CSD! Check selected channels.','warning','modal');
    return;
end
if isempty(DefAnsw)
    DefAnsw{1} = '1';
    DefAnsw{2} = 'auto';
    DefAnsw{3} = '20';
    DefAnsw{4} = 'no';
    DefAnsw{5} = 'no';
end    
DefAnsw = inputdlg({'Generator numbers (use {} to group, e.g. {1,2} 3):',...
    'Color max limit (e.g. 2e-3 or auto):',...
    'Color gradations:','Subtract median (yes/no):','Show grid (yes/no)'},...
    'Define CSD parameters',1,DefAnsw);
if isempty(DefAnsw), return; end
xlm = get(handles.axes1,'Xlim');
eval(['sg = {' DefAnsw{1} '};']);
nPlots = length(sg);
Answer = DefAnsw;
if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
scrsz = get(0, 'ScreenSize'); % get screen size
figure('color','w','Position', [10 10 scrsz(3)-20 , scrsz(4)-40]);
for k = 1:nPlots
    subplot(nPlots,1,k)
    set(gca,'Xlim',xlm);
    if iscell(sg{k})
        ss = sg{k};
        Answer{1} = num2str([ss{1:end}]);
    else
        Answer{1} = num2str(sg{k});
    end
    ComputeAndDrawCSD(Answer, Args.Fs, G.T0, Chns, G.s, G.V, Type2deriv);
    PlotStimulusPositions(Args)
    title(['CSD for G: ' Answer{1}])
end
%print(['-f' num2str(h)],'-dmeta') 
%uiwait(msgbox('The figure has been copied to the clipboard, Ctrl+v to paste'));
% close(h);

% --------------------------------------------------------------------
function PPtriggeredICA_Callback(hObject, eventdata, handles)
% hObject    handle to PPtriggeredICA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Args LFP G Axis1Flag
if isempty(LFP), return; end

if ~strcmp(Axis1Flag,'LFPs')
    errordlg('Plot Original LFPs in a time window, and THEN use this tool.', 'Error');
    return;
end

xlm = get(handles.axes1,'Xlim');
tt = round(Args.Fs*(xlm - Args.T0));
if tt(1) < 1, tt(1) = 1; xlm(1) = Args.T0; end
tt(2) = min(tt(2),size(LFP,2));

Tartfc = Args.ArtfctIDX;
DT1 = Tartfc(2) - Tartfc(1);
DT2 = Tartfc(3) - Tartfc(2);
if abs(DT1/DT2 - 1) > 0.1
    % double pulse, delete secondary pulses
    DT = diff(Tartfc);
    Tartfc = Tartfc(abs(DT/DT1 - 1) < 0.1);
end
dStim = mean(diff(Tartfc));
Tartfc = Tartfc(Tartfc >= tt(1) & Tartfc <= tt(2));  

answer = inputdlg({'From (in ms relative to the 1st stimulus):','To (in ms relative to the 1st stimulus):'},...
    'Define ICA trigger parameters',1,{'1','30'});
if isempty(answer), return; end
wt(1) = round(1e-3*str2num(answer{1})*Args.Fs);
wt(2) = round(1e-3*str2num(answer{2})*Args.Fs);
if wt(2) <= wt(1)+16 || wt(2) > dStim,
    errordlg('Selected triggered window is incompatible with the LFP.', 'Error');
    return;
end
X = [];
for k = 1:length(Tartfc)
    X = [X LFP(:,Tartfc(k) + [wt(1):wt(2)])];
end
axes(handles.axes1)
hold off; cla;
Chns = str2num(get(handles.ElectrodeRange,'String'));
leg = num2str(Chns');
leg = mat2cell(leg,ones(1,size(leg,1)),size(leg,2));
PlotEEG(X(Chns,:),Args.Fs,leg,[],'concatenated LFPs for triggered ICA');
answer = questdlg('Approve the selected LFP portion?', 'Check concatenated LFP plot','Yes','No','Yes');
if isempty(answer) || strcmp(answer,'No'), 
    Axis1Flag = 'LFPs';
    set(handles.axes1,'Xlim',xlm);
    PlotLFPs_Callback(hObject, eventdata, handles)
    return; 
end

h = msgbox('Triggered ICA of LFPs, don''t press any key, JUST WAIT!');
NDIM = rank(X);
[A, s, niters, idIN] = ICA_1(X, NDIM, 'off');
G = [];
if isempty(idIN), idIN = [1, 2]; end
G.V = A; G.s = pinv(A)*LFP(:,tt(1):tt(2)); G.T0 = xlm(1); G.ID = idIN;
set(handles.axes1,'Xlim',xlm);
set(handles.SelectedLoadings,'String',num2str(G.ID));
PlotGenerators_Callback(hObject, eventdata, handles);
close(h)


% --------------------------------------------------------------------
function GroupLoadings_Callback(hObject, eventdata, handles)
global G
if isempty(G), return; end


set(handles.axes3,'Visible','off')
set(handles.axes4,'Visible','off')
set(handles.axes2,'Visible','on')
axes(handles.axes2);
cla; hold off;
if strcmpi(get(handles.CosineDistance,'Checked'),'on'),
    G = GroupLoadings(G, 'cos');
end
if strcmpi(get(handles.SetDistanceH0,'Checked'),'on'),
    G = GroupLoadings(G, 'H0');
end
if strcmpi(get(handles.SetDistanceH1,'Checked'),'on'),
    G = GroupLoadings(G, 'H1');
end
if strcmpi(get(handles.SetDistanceH2,'Checked'),'on'),
    G = GroupLoadings(G, 'H2');
end
PlotGenerators_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function CosineDistance_Callback(hObject, eventdata, handles)
set(handles.CosineDistance,'Checked','on');
set(handles.SetDistanceH0, 'Checked','off');
set(handles.SetDistanceH1, 'Checked','off');
set(handles.SetDistanceH2, 'Checked','off');
% --------------------------------------------------------------------
function SetDistanceH0_Callback(hObject, eventdata, handles)
set(handles.CosineDistance,'Checked','off');
set(handles.SetDistanceH0, 'Checked','on');
set(handles.SetDistanceH1, 'Checked','off');
set(handles.SetDistanceH2, 'Checked','off');
% --------------------------------------------------------------------
function SetDistanceH1_Callback(hObject, eventdata, handles)
set(handles.CosineDistance,'Checked','off');
set(handles.SetDistanceH0, 'Checked','off');
set(handles.SetDistanceH1, 'Checked','on');
set(handles.SetDistanceH2, 'Checked','off');
% --------------------------------------------------------------------
function SetDistanceH2_Callback(hObject, eventdata, handles)
set(handles.CosineDistance,'Checked','off');
set(handles.SetDistanceH0, 'Checked','off');
set(handles.SetDistanceH1, 'Checked','off');
set(handles.SetDistanceH2, 'Checked','on');


% --------------------------------------------------------------------
function PlotGeneratorDerivatives_Callback(hObject, eventdata, handles)
global Args G Axis1Flag GnrsSet
if isempty(G), return; end
set(handles.axes2,'Visible','off')
set(handles.ChannelGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','on')

idIN = str2num(get(handles.SelectedLoadings,'String'));
idIN = intersect(1:size(G.s,1),idIN);
set(handles.SelectedLoadings,'String',num2str(idIN));
G.ID = idIN;

axes(handles.axes3)
hold off; cla;
PlotLoadings(G.V, [], idIN)
title('voltage loadings')
set(handles.axes3,'Visible','on')

du = Derivative_1D(G.V, '1central');
axes(handles.axes4)
hold off; cla;
PlotLoadings(du,[],idIN)
title('voltage loading derivatives')
set(handles.axes4,'Visible','on')


% --------------------------------------------------------------------
function DefineNDIM_Callback(hObject, eventdata, handles)
set(handles.autoNDIM,'Checked','off');
set(handles.DefineNDIM, 'Checked','on');
answer = inputdlg({'NDIM for ICA'}, 'Define ICA dimension',1);
if isempty(answer), return; end
set(handles.DefineNDIM,'Label',['NDIM = ' num2str(answer{1})])

% --------------------------------------------------------------------
function autoNDIM_Callback(hObject, eventdata, handles)
set(handles.autoNDIM,'Checked','on');
set(handles.DefineNDIM, 'Checked','off');


% --------------------------------------------------------------------
function SaveCSDtoFile_Callback(hObject, eventdata, handles)
global CSD2save

if isempty(CSD2save), return; end
CSD = CSD2save.CSD;
Time = CSD2save.Time;
Channels = CSD2save.Chanels;
[fn, FDIR] = uiputfile('*.mat', 'Save CSD');
if isnumeric(fn), return; end
file = fullfile(FDIR,fn);
save(file,'CSD','Time','Channels');
msgbox('CSD data have been saved.');


% --------------------------------------------------------------------
% --------------------------------------------------------------------
% --------------------------------------------------------------------
function WTofSpikeTrain_Callback(hObject, eventdata, handles)
global Trains
if isempty(Trains), return; end

xlm = get(handles.axes1,'Xlim');
FlagNormaliz = get(handles.WTSpNorm, 'Checked');
[E, WTarg] = WTEnergySpectrum(Trains, xlm, FlagNormaliz);
% make plot
Emax = max(E(:));
axes(handles.axes3); hold off; cla;
set(handles.axes3,'Visible','off')
axes(handles.axes4); hold off; cla;
set(handles.axes4,'Visible','off')
axes(handles.axes2); hold off; cla;
set(handles.axes2,'Visible','on')
Eplot = 1 + 63*(WTarg.MaxPowOrders + log10(E/Emax))/WTarg.MaxPowOrders;
image(WTarg.t, log2(WTarg.p), Eplot);
xlim(xlm)
tks = get(gca,'YTick')';
id = (tks - fix(tks) == 0);
set(gca,'YTick', tks(id));
set(gca,'YTickLabel', num2str(1./(2.^tks(id)),3),'TickDir','out')
ylabel('frequency (Hz)')
title(['WT spectrum for train ' Trains.Titles(WTarg.nTrn,:)])
h = colorbar('location','East');
set(h,'YTick',linspace(1,64,WTarg.MaxPowOrders+1))
set(h,'YTickLabel',num2str(Emax*10.^(-WTarg.MaxPowOrders:0)','%2.2g'))

% --------------------------------------------------------------------
function WTSpNOnorm_Callback(hObject, eventdata, handles)
set(handles.WTSpNorm,'Checked','off');
set(handles.WTSpNOnorm, 'Checked','on');


% --------------------------------------------------------------------
function WTSpNorm_Callback(hObject, eventdata, handles)
set(handles.WTSpNorm,'Checked','on');
set(handles.WTSpNOnorm, 'Checked','off');


% --------------------------------------------------------------------
function SpectralRidges_Callback(hObject, eventdata, handles)
global Trains
if isempty(Trains), return; end

xlm = get(handles.axes1,'Xlim');
FlagNormaliz = get(handles.WTSpNorm, 'Checked');
[E, WTarg] = WTEnergySpectrum(Trains, xlm, FlagNormaliz);
Emax = max(E(:));
id = WTarg.MaxPowOrders + log10(E/Emax) < 0;
E(id) = 0;
% make plot
axes(handles.axes2)
hold off; cla;
set(handles.axes2,'Visible','on')

for k = 1:size(E,2),
    y = E(:,k);
    idx = find(y(1:end-2) < y(2:end-1) & y(2:end-1) > y(3:end));
    if ~isempty(idx)
        idx = idx + 1;
        clr = -log10(y(idx)/Emax)/WTarg.MaxPowOrders;
        for jj = 1:length(idx),
            plot(WTarg.t(k),log2(WTarg.p(idx(jj))),'.','MarkerEdgeColor',clr(jj)*[1 1 1])
            hold on
        end
    end
end
xlim(xlm)
set(gca,'YDir', 'reverse');
tks = get(gca,'YTick')';
id = (tks - fix(tks) == 0);
set(gca,'YTick', tks(id));
set(gca,'YTickLabel', num2str(1./(2.^tks(id)),3),'TickDir','out')
ylabel('frequency (Hz)')
title(['Spectrum ridges for train ' Trains.Titles(WTarg.nTrn,:)])


% --------------------------------------------------------------------
function GenerateCustomTrain_Callback(hObject, eventdata, handles)
global Trains
ttt = '1234567abcdefghklmnopqr';
Spikes = CreateNewTrain;
if isempty(Spikes), return; end
if isempty(Trains),
    k = 1;
else
    k = 1 + length(Trains.Spikes);
end
if k > 1,
    Trains.Titles(k,:) = Trains.Titles(k-1,:);
    tt = setdiff(ttt,Trains.Titles(:,1));
    Trains.Titles(k,1) = tt(1);
else
    Trains.Titles(k,1) = '1';
end    
Trains.Spikes{k} = Spikes(:);
PlotSpikeTrains_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function MultiThreadEnable_Callback(hObject, eventdata, handles)
nPools = matlabpool('size');
if nPools > 0,
    set(handles.MultiThreadEnable,'Checked','on');
    set(handles.MultiThreadDisable, 'Checked','off');
else
    try
        matlabpool open
    catch ME
        errordlg('Cannot start parallel jobs')
        return
    end
    set(handles.MultiThreadEnable,'Checked','on');
    set(handles.MultiThreadDisable, 'Checked','off');
end



% --------------------------------------------------------------------
function MultiThreadDisable_Callback(hObject, eventdata, handles)
set(handles.MultiThreadEnable,'Checked','off');
set(handles.MultiThreadDisable, 'Checked','on');
nPools = matlabpool('size');
if nPools > 0,
    matlabpool close
end



% --------------------------------------------------------------------
function CustomArrange_Callback(hObject, eventdata, handles)
global LFP Args
if isempty(LFP), beep; return; end

if isfield(Args,'ElctrArrangement') && ~isempty(Args.ElctrArrangement)
    ButtonName = questdlg('The channels have ALREADY been arranged!','PROBLEM DETECTED', 'cancel','proceed anyway', 'cancel');
    if strcmpi(ButtonName,'cancel')
        return;
    end
end    

[fn, fd] = uigetfile({'*.txt'}, 'Pick a file with electrode config.');
if fn == 0, beep; return; end
file = fullfile(fd,fn);
try 
    ElArray = load(file); % electrode config 1
catch
    errordlg('wrong file format');
    return
end
if ~isnumeric(ElArray) || length(ElArray) ~= size(LFP,1)
    errordlg('The electrode configuration does not match the LFP size');
    return
end    
Args.ElctrArrangement = fn;
LFP = LFP(ElArray,:);
PlotLFPs_Callback(hObject, eventdata, handles)
set(handles.ArangeElectrodes,'Enable','off')
set(handles.CustomArrange,'Enable','off')
uiwait(msgbox(['Electrodes have been arranged according to: ' Args.ElctrArrangement ' order.']))

% --------------------------------------------------------------------
function ArangeElectrodes_Callback(hObject, eventdata, handles)
global LFP Args
if isempty(LFP), beep; return; end

if isfield(Args,'ElctrArrangement') && ~isempty(Args.ElctrArrangement)
    ButtonName = questdlg('The channels have ALREADY been arranged!','PROBLEM DETECTED', 'cancel','proceed anyway', 'cancel');
    if strcmpi(ButtonName,'cancel')
        return;
    end
end    
    
if size(LFP,1) == 16,
    ButtonName = questdlg('Select arrangement', '16 channels file', 'Plexon', 'MCRack', 'Plexon');
    switch ButtonName
        case 'Plexon'
            ElArray = load('FilaConf16.txt'); % electrode config 1
            Args.ElctrArrangement = 'Plexon Fila 16';
        case 'MCRack'
            ElArray = load('FilaConf16_MCR.txt'); % electrode config 1
            Args.ElctrArrangement = 'MCRack Fila 16';
    end
elseif size(LFP,1) == 32,
    inputOptions={'1 linear', '2 shanks', '4 shanks', 'El Mono'};
    defSelection=inputOptions{1};
    iSel=bttnChoiseDialog(inputOptions, '32 sites electrode', defSelection,...
        'What is the arrangement?');
    ButtonName = inputOptions{iSel};
    
    switch ButtonName
        case '1 linear'
            ElArray = load('FilaConf32.txt');
            Args.ElctrArrangement = 'MCRack Fila 32';
        case '2 shanks'
            ElArray = load('FilaConf2x16.txt'); 
            Args.ElctrArrangement = 'MCRack Fila 2x16';
        case '4 shanks'
            ElArray = load('FilaConf4x8.txt'); 
            Args.ElctrArrangement = 'MCRack Fila 4x8';
        case 'El Mono'
            ElArray = load('FilaConf32_Mono.txt'); 
            Args.ElctrArrangement = 'MCRack Mono 32';
    end
elseif size(LFP,1) == 31,
    ElArray = load('FilaConf31_Chronic.txt');
    Args.ElctrArrangement = 'MCRack Chronic Fila 31';
elseif size(LFP,1) == 24,
    ElArray = load('FilaConf24_Mono.txt');
    Args.ElctrArrangement = 'MCRack Mono 24';
else
    errordlg('The number of LFPs must be either 16 or 32 for acute or 31 for chronic', 'warning','modal')
    return;
end
LFP = LFP(ElArray,:);
PlotLFPs_Callback(hObject, eventdata, handles)
set(handles.ArangeElectrodes,'Enable','off')
set(handles.CustomArrange,'Enable','off')
uiwait(msgbox(['Electrodes have been arranged according to: ' Args.ElctrArrangement ' order.']))



% --------------------------------------------------------------------
function EliminatePPartifacts_Callback(hObject, eventdata, handles)
global LFP Args Axis1Flag
if isempty(LFP), return; end
if ~isfield(Args,'EpochLength'), 
    uiwait(errordlg('LFPs have no PP-epochs. Results may be incorrect!', 'warning', 'modal'));
end
Axis1Flag = 'LFPs';
ShowAll_Callback(hObject, eventdata, handles)

axes(handles.axes2)
cla
hold off; 
set(handles.axes2,'Visible','on')
set(handles.axes3,'Visible','off')
set(handles.axes4,'Visible','off')
%[LFP, Args] = EliminatePPartifacts2(mean(LFP,2), Args);
Args = EliminatePPartifacts2(LFP, Args);

answ = inputdlg({'Artifact length (ms):'},'Input',1,{'[0 1.3]'});
if isempty(answ), return; end
lArtf = str2num(answ{1});
if length(lArtf) ~=2 || lArtf(1) > lArtf(2)
    uiwait(errordlg('Check time limits!','warning','modal'));
    return
end
D = [lArtf(1) - 0.6, lArtf(1) - 0.3, lArtf(2), lArtf(2) + 0.3];
ii =  round(D([1,4])*Args.Fs*1e-3);
iS = Args.ArtfctIDX;
iS(iS < ii(1)) = []; iS(iS > size(LFP,2) - ii(2)) = [];
RemoveLFPArtifacts(iS, Args.Fs, D)
PlotLFPs_Callback(hObject, eventdata, handles)
set(handles.EliminatePPartifacts,'Enable','off')

% --------------------------------------------------------------------
function EliminateTriggerArtifacts_Callback(hObject, eventdata, handles)
global LFP Args Trains
if isempty(LFP) || isempty(Trains), return; end

answ = inputdlg({['Trigger (available from: ' Trains.Titles(1,:) ' to '...
    Trains.Titles(end,:) ')'],...
    'Artifact length (ms):'},'Input',1,{Trains.Titles(1),'[0 1.3]'});
if isempty(answ), return; end
[dum,nTrig] =  intersect(str2num(Trains.Titles),str2num(answ{1}));
if isempty(dum), 
    uiwait(errordlg('No such channel exists.','warning','modal')); 
    return
end
lArtf = str2num(answ{2});
if length(lArtf) ~=2 || lArtf(1) > lArtf(2)
    uiwait(errordlg('Check time limits!','warning','modal'));
    return
end
D = [lArtf(1) - 0.6, lArtf(1) - 0.3, lArtf(2), lArtf(2) + 0.3];
ii =  round(D([1,4])*Args.Fs*1e-3);
iS = round(Trains.Spikes{nTrig}*Args.Fs);
iS(iS < ii(1)) = []; iS(iS > size(LFP,2) - ii(2)) = [];
Args.ArtfctIDX = iS;
RemoveLFPArtifacts(iS, Args.Fs, D)
PlotLFPs_Callback(hObject, eventdata, handles)



% --------------------------------------------------------------------
function EliminatePPoffset_Callback(hObject, eventdata, handles)
global LFP Args
if isempty(LFP), return; end
if ~isfield(Args,'EpochLength'), 
    uiwait(errordlg('LFPs have no PP-epochs.', 'warning', 'modal'));
    return;
end
epchL = Args.EpochLength;  % epoch length
epchN = size(LFP,2)/epchL; % number of epochs (stimuli)
mLFPepch = zeros(size(LFP,1),epchN);
t2 = round(0.003*Args.Fs); % first 3 ms to estimate offset
for k = 1:epchN,
    t1 = 1 + (k-1)*epchL;
    t11 = k*epchL;
    mLFPepch(:,k) = mean(LFP(:,t1:t1+t2),2);
    LFP(:,t1:t11) = LFP(:,t1:t11) - mLFPepch(:,k)*ones(1,epchL);
end
Args.LFPepochOffSets = mLFPepch;
h = figure('color','w');
PlotLoadings(mLFPepch,'.')
title('DC offsets for each PP')
print(['-f' num2str(h)],'-dmeta') 
uiwait(msgbox('The figure has been copied to the clipboard, Ctrl+v to paste'));

PlotLFPs_Callback(hObject, eventdata, handles)
set(handles.EliminatePPoffset,'Enable','off')




function Yscale_Callback(hObject, eventdata, handles)
global Axis1Flag

switch Axis1Flag
    case 'LFPs'
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'G'
        PlotGenerators_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        PlotCA1LFPs_Callback(hObject, eventdata, handles)
    case 'dLFPs'
        PlotTimeDerivatives_Callback(hObject, eventdata, handles)
    case 'mTG'
        PlotMeanTriggeredICs_Callback(hObject, eventdata, handles)
    case 'Tetrode'
        PlotTetrode_Callback(hObject, eventdata, handles)
end        

% --- Executes during object creation, after setting all properties.
function Yscale_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function MINMAXarrangeICs_Callback(hObject, eventdata, handles)
global G
if isempty(G), return; end

[V, s, Factors, Noise] = TestICsForCSDcontribution(G.V, G.s);
idIN = find(Factors > 0.05*sum(Factors));
nn = Noise(idIN);
G.V = V; G.s = s; G.ID = idIN(:)';

set(handles.SelectedLoadings,'String',num2str(G.ID));
set(handles.Yscale,'String','auto')
PlotGenerators_Callback(hObject, eventdata, handles)
axes(handles.axes3)
hold off
bar(100*Factors/sum(Factors));
title(['nICs = ' num2str(length(nn)) '; Mean noise = ' num2str(mean(nn))])
ylabel('Contribution to CSD (%)')
xlabel('IC')


% --------------------------------------------------------------------
function DenoiseS_Callback(hObject, eventdata, handles)
global G
if isempty(G), return; end

thr = get(handles.SetDenoiseThreshold,'Label');
try
    eval([thr ';'])
catch me
    set(handles.SetDenoiseThreshold,'Label','Th = 3.6');
    errordlg('Check options: Wrong threshold. Must be a number!','warning','modal');
    return
end
    
s = G.s;
h = waitbar(0,'Please wait...');
for k = 1:size(s,1),
    waitbar(k/size(s,1),h);
    s(k,:) = SWTdenoise(s(k,:), Th, 10);
end
G.s = s;
%set(handles.Yscale,'String','auto')
PlotGenerators_Callback(hObject, eventdata, handles)
close(h)


% --------------------------------------------------------------------
function SetDenoiseThreshold_Callback(hObject, eventdata, handles)
answer = inputdlg({'Threshold multiplayer for denoising:'}, 'input',1);
if isempty(answer), return; end
set(handles.SetDenoiseThreshold,'Label',['Th = ' num2str(answer{1})])


% --------------------------------------------------------------------
function SmartICA_Callback(hObject, eventdata, handles)
global Args LFP G LFP_CA1 Axis1Flag  Artfcts
if isempty(LFP), return; end
if ~strcmpi(Axis1Flag,'LFPs'), 
    errordlg('First plot LFPs and select the time interval for ICA.','warning','modal');
    return; 
end
xlm = get(handles.axes1,'Xlim');
nChns = size(LFP,1);

answer = inputdlg({'NDIMs to test ([Start:Step:End]):'}, 'input',1,{['[2:2:' num2str(nChns) ']']});
if isempty(answer), return; end
NDIM = intersect(2:nChns,str2num(answer{1}));
if isempty(NDIM),
    errordlg(['Select NDIMs withing [2,' num2str(nChns) '] limits.'],'warning','modal');
    return; 
end
    
h = msgbox('Please wait. May take time...');

tt = round(Args.Fs*(xlm - Args.T0));
tt(1) = max(tt(1), 1);
tt(2) = min(tt(2), size(LFP,2));
X = LFP(:,tt(1):tt(2));
mNoise = zeros(1,length(NDIM));
nICs = zeros(1,length(NDIM));
parfor k = 1:length(NDIM),
    [A, s] = ICA_1(X, NDIM(k), 'off');
    [V, s, Factors, Noise] = TestICsForCSDcontribution(A, s);
    idIN = find(Factors > 0.05*sum(Factors));
    mNoise(k) = mean(Noise(idIN));
    nICs(k) = length(idIN);
    disp(k)
end
close(h)
nMin = 1 + ceil(median(nICs(diff(nICs) == 0)));
if isempty(nMin), nMin = median(nICs) + 1; end
nMax = min(nChns,max(nICs)+2);

axes(handles.axes2); cla; set(handles.axes2,'Visible','off')
set(handles.axes3,'Visible','on')
set(handles.axes4,'Visible','on')
axes(handles.axes3)
hold off
plot(NDIM,nICs,'o-');
ylabel('number of informative ICs')
xlabel('NDIM')
axes(handles.axes4)
hold off
plot(NDIM,mNoise,'o-');
ylabel('mean noise level')
xlabel('NDIM')
uiwait(msgbox(['Reccomended NDIM: form ' num2str(nMin) ' to ' num2str(nMax)]));


% --------------------------------------------------------------------
function RasterGeneratorPlot_Callback(hObject, eventdata, handles)
global Args LFP G
persistent answer;
if isempty(G), return; end
if ~isfield(Args,'ArtfctIDX') || isempty(Args.ArtfctIDX),
    errordlg('Seems no PP recording. Check stimulus positions.','warning','modal');
    return;
end

if isempty(answer)
    answer{1} = '1';
    answer{2} = 'all';
    answer{3} = 'auto';
    answer{4} = 'auto';
    answer{5} = 'auto';
    answer{6} = 'none';
    answer{7} = '10';
end

answer = inputdlg({'Select IC for the raster plot:',...
    'Stimulus events e.g. [1:12] or all:',...
    'Time limits (s) e.g. [0.01, 0.02] or auto:','Y scale',...
    'Color limits e.g. [-4e-3, 0] or auto',...
    'Equipotential color e.g. none, k, b, etc:',...
    'Color gradations:'}, 'input',1, answer);
if isempty(answer), return; end

nICs = size(G.s,1);
nG = intersect(1:nICs,str2num(answer{1}));
if isempty(nG), 
    errordlg('Wrong IC number.','warning','modal');
    return;
end
L = Args.EpochLength;
s = zeros(1,size(LFP,2));
t1 = floor(G.T0*Args.Fs);
t2 = size(G.s,2);
s(t1 + (1:t2)) = G.s(nG,:);
nPPs = length(s)/L;
RasterS = reshape(s,L,nPPs)';

if strcmpi(answer{2},'all'),
    Chns = 1:nPPs;
else
    Chns = intersect(1:nPPs,str2num(answer{2}));
end
if length(Chns) < 2, 
    errordlg('Wrong stimulus events.','warning','modal');
    return;
end

Tlims = str2num(answer{3});
if isempty(Tlims) || length(Tlims) ~= 2, 
    Tlims = [1 L]/Args.Fs; 
end
tt = floor(Tlims*Args.Fs);
tt(1) = max(1,tt(1));
tt(2) = min(L,tt(2));
if diff(tt) < 2,
    errordlg('Wrong time limits.','warning','modal');
    return;
end

yscale = str2num(answer{4});
axes(handles.axes3); cla;
axes(handles.axes4); cla;
set(handles.axes2,'Visible','on')
set(handles.axes3,'Visible','off')
set(handles.axes4,'Visible','off')
axes(handles.axes2)
hold off;
PlotLFPTraces(RasterS(Chns,:), Args, Tlims(1), diff(Tlims),...
    ['Raster plot for G' answer{1}],'st',[],yscale);

RasterS = RasterS(:,tt(1):tt(2));
if strcmpi(answer{5},'auto')
    Cmax = [min(RasterS(:)) max(RasterS(:))];
else
    Cmax = sort(str2num(answer{5}));
end

if ~any(strcmpi(answer{6},{'none','b','g','r','c','y','m','k','w'})),
    answer{6} = 'none';
end
nClrs = str2num(answer{7});
if isempty(nClrs) || nClrs < 2 || nClrs > 20,
    nClrs = 10; answer{7} = '10';
end
axes(handles.axes1)
hold off
vv = linspace(Cmax(1),Cmax(2), nClrs);
contourf((tt(1):tt(2))/Args.Fs, Chns,...
    RasterS(Chns,:), vv, 'LineColor', answer{6});
title(['Raster plot for G' answer{1}]);
xlabel('time (s)'); ylabel('stimulus event') 
set(gca,'YDir','reverse')
set(gca,'CLim',Cmax)
colorbar('location','East')
colormap('hot')

% --------------------------------------------------------------------
function InvertSignforICs_Callback(hObject, eventdata, handles)
global G 
if isempty(G), return; end
answer = inputdlg({'Chose the IC to invert signs in loadings and activation:'}, 'input',1);
if isempty(answer), return; end
nG = str2num(answer{1});
G.s(nG,:) = -G.s(nG,:);
G.V(:,nG) = -G.V(:,nG);
PlotGenerators_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function SimulateLFPs_Callback(hObject, eventdata, handles)
global Args LFP_CA1 G Axis1Flag LFP
persistent answer

if isempty(G), return; end
if isempty(answer),
    answer{1} = '1';
end
answer = inputdlg({'Chose the ICs composing LFPs:'}, 'input',1,answer);
if isempty(answer), return; end
nG = intersect(1:size(G.s,1),str2num(answer{1}));
if isempty(nG)
    errordlg('Wrong ICs.','warning','modal');
    return;
end
LFP_CA1 = zeros(size(G.V,1),size(LFP,2));
t1 = round(Args.Fs*G.T0); t2 = size(G.s,2) - 1;
t1 = max(1,t1);
LFP_CA1(:,t1:(t1+t2)) = G.V(:,nG)*G.s(nG,:);
Args.CA1 = 1:size(LFP_CA1,1);
Axis1Flag = 'CA1_LFPs';
PlotCA1LFPs_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function SimulateS_Callback(hObject, eventdata, handles)
global Args G Axis1Flag LFP
persistent answer

if isempty(G), return; end
if isempty(answer),
    answer{1} = '[1:4]';
end
answer = inputdlg({'Chose the Loadings to compose s:'}, 'input',1,answer);
if isempty(answer), return; end
nG = intersect(1:size(G.V,2),str2num(answer{1}));
if isempty(nG)
    errordlg('Wrong ICs.','warning','modal');
    return;
end
G.T0 = Args.T0;
G.V = G.V(:,nG);
G.s = pinv(G.V)*LFP;
PlotGenerators_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function DropOffsetAtPoint_Callback(hObject, eventdata, handles)
global Args G LFP Axis1Flag
switch Axis1Flag
    case 'G'
        if isempty(G), return; end
        axes(handles.axes1)
        [t,y1,but] = ginput(1);
        if but ~= 1, return; end
        id = round(Args.Fs*(t - G.T0));
        if id < 3, id = 3; end
        mS = mean(G.s(:,id + (-2:2)),2);
        G.s = G.s - mS*ones(1,size(G.s,2));
        PlotGenerators_Callback(hObject, eventdata, handles)
    case 'LFPs'
        if isempty(LFP), return; end
        axes(handles.axes1)
        [t,y1,but] = ginput(1);
        if but ~= 1, return; end
        id = round(Args.Fs*(t - Args.T0));
        if id < 3, id = 3; end
        mLFP = mean(LFP(:,id + (-2:2)),2);
        LFP = LFP - mLFP*ones(1,size(LFP,2));
        PlotLFPs_Callback(hObject, eventdata, handles)
end


% --------------------------------------------------------------------
function ArrangeICsManually_Callback(hObject, eventdata, handles)
global G mTG
if isempty(G), return; end
answer = inputdlg({'Put ICs in a desired order (e.g. [6 3 1])'}, 'input',1);
if isempty(answer), return; end
nGenFirst = str2num(answer{1});
[dum, ia] = intersect(nGenFirst, 1:size(G.s,1));
nGenFirst = nGenFirst(sort(ia));
nGenFirst  = [nGenFirst, setdiff(1:size(G.s,1),nGenFirst)];
G.s = G.s(nGenFirst,:);
G.V = G.V(:,nGenFirst);
if ~isempty(mTG), errordlg('If necessary, recompute mean triggered activations.','warning','modal'); end 
PlotGenerators_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function ICAofCSD_Callback(hObject, eventdata, handles)
global Args G Axis1Flag CSD2save
if isempty(CSD2save), return; end
% xlm = get(handles.axes1,'Xlim');
if strcmpi(get(handles.DefineNDIM, 'Checked'),'on')
    eval([get(handles.DefineNDIM,'Label') ';']);
else
    NDIM = 'auto';
end
X = CSD2save.CSD(2:end-1,:);
if ~isnumeric(NDIM) || NDIM > rank(X)
    NDIM = rank(X);
    uiwait(msgbox(['Current NDIM = ' num2str(NDIM) '.']));
end
[A, s, niters, idIN] = ICA_1(X, NDIM, 'off');
G = [];
if isempty(idIN), idIN = [1, 2]; end
G.V = A; G.s = s; G.T0 = CSD2save.Time(1); G.ID = idIN;
set(handles.SelectedLoadings,'String',num2str(G.ID));
PlotGenerators_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function ConourLFPplot_Callback(hObject, eventdata, handles)
global Args LFP_CA1
persistent DefAnsw
if isempty(LFP_CA1),
    errordlg('Can be applied to CA1 LFP only. No CA1 defined.', 'Error');
    return;
end
Chns = intersect((1:size(LFP_CA1,1)),str2num(get(handles.ElectrodeRange,'String')));
if length(Chns) < 2,
    errordlg('Not enough channels for CSD! Check selected channels.','warning','modal');
    return;
end
if isempty(DefAnsw)
    DefAnsw{1} = 'auto';
    DefAnsw{2} = '20';
    DefAnsw{3} = 'no';
end    
DefAnsw = inputdlg({'Color max limit (e.g. 2e-3 or auto):',...
    'Color gradations:','Show grid (yes/no)'},...
    'Define CSD parameters',1,DefAnsw);
if isempty(DefAnsw), return; end

axes(handles.axes1)
cla; hold off
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
answer{1} = '1'; answer{2} = DefAnsw{1};  answer{3} = DefAnsw{2}; 
answer{4} = 'no'; answer{5} = DefAnsw{3}; 
if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
    Type2deriv = '2improved';
else
    Type2deriv = '2simple';
end
ComputeAndDrawCSD(answer, Args.Fs, Args.T0, Chns, LFP_CA1, [], Type2deriv);
PlotStimulusPositions(Args)
title('Countour plot for CA1 LFP')
% Axis1Flag = 'G_CSD';


% --------------------------------------------------------------------
function PlotTimeDerivatives_Callback(hObject, eventdata, handles)
global Args LFP Axis1Flag
if isempty(LFP), return; end
if ~any(strcmpi(Axis1Flag,{'LFPs','dLFPs'}))
    errordlg('First plot LFPs.','warning','modal');
    return;
end
axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
Chns = intersect((1:size(LFP,1)),str2num(get(handles.ElectrodeRange,'String')));
if isempty(Chns), return; end
if strcmpi(Axis1Flag,'dLFPs')
    yscale = str2num(get(handles.Yscale,'String'));
else
    set(handles.Yscale,'String','auto');
    yscale = [];
end
ChTitle = ['e'*ones(length(Chns),1) num2str(Chns(:))];
ChTitle = mat2cell(ChTitle,ones(size(ChTitle,1),1),size(ChTitle,2));
Y = 0.5*Args.Fs*(LFP(Chns,3:end) - LFP(Chns,1:end-2));
Y = [Y(:,1) Y  Y(:,end)];
PlotLFPTraces(Y, Args, Tlim(1), diff(Tlim),[],ChTitle,[],yscale);
title('LFP time derivatives')
PlotStimulusPositions(Args)
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
Axis1Flag = 'dLFPs';


% --------------------------------------------------------------------
function DecimateLFP_Callback(hObject, eventdata, handles)
global Args LFP
if isempty(LFP), return; end
answ = inputdlg({'Decimating rate (from 2 to 10):}'},'Input',1,{'5'});
if isempty(answ), return; end
r = intersect(2:10,str2num(answ{1}));
if isempty(r), 
     uiwait(errordlg('Wrong rate. No action taken.','warning','modal'));
end

[nChs, nPts] = size(LFP);
newPts = ceil(nPts/r);
for k = 1:nChs,
    LFP(k,1:newPts) = decimate(LFP(k,:),r);
end
LFP = LFP(:,1:newPts);
Args.Fs = Args.Fs/r;
if isfield(Args,'ArtfctIDX'),
    Args.ArtfctIDX = round(Args.ArtfctIDX/r);
end
PlotLFPs_Callback(hObject, eventdata, handles)
set(handles.StatusFs,'String',['Fs = ' num2str(1e-3*Args.Fs,2) ' kHz'])

% --------------------------------------------------------------------
function PlotBest_Callback(hObject, eventdata, handles)
set(handles.PlotBest,'Checked','on')
set(handles.PlotIntermediate,'Checked','off')
set(handles.PlotWorst,'Checked','off')
% --------------------------------------------------------------------
function PlotIntermediate_Callback(hObject, eventdata, handles)
set(handles.PlotBest,'Checked','off')
set(handles.PlotIntermediate,'Checked','on')
set(handles.PlotWorst,'Checked','off')
% --------------------------------------------------------------------
function PlotWorst_Callback(hObject, eventdata, handles)
set(handles.PlotBest,'Checked','off')
set(handles.PlotIntermediate,'Checked','off')
set(handles.PlotWorst,'Checked','on')



% --------------------------------------------------------------------
function PlotMeanTriggeredLFPs_Callback(hObject, eventdata, handles)
global LFP Args Trains Axis1Flag
if isempty(LFP) || isempty(Trains), return; end

[id, nTrig, T0] = SelectTrigger(Trains, Args.Fs, [1 size(LFP,2)]);
nPts = size(id,2);
mTLFP = zeros(size(LFP,1), nPts);
for j = 1:nPts,
    mTLFP(:,j) = mean(LFP(:,id(:,j)),2);
end

axes(handles.axes1)
Chns = intersect((1:size(LFP,1)),str2num(get(handles.ElectrodeRange,'String')));
if isempty(Chns), return; end
if strcmpi(Axis1Flag,'mTLFPs')
    yscale = str2num(get(handles.Yscale,'String'));
else
    set(handles.Yscale,'String','auto');
    yscale = [];
end
ChTitle = ['e'*ones(length(Chns),1) num2str(Chns(:))];
ChTitle = mat2cell(ChTitle,ones(size(ChTitle,1),1),size(ChTitle,2));
PlotLFPTraces(mTLFP(Chns,:), Args, 0, nPts/Args.Fs,...
    ['mean LFPs triggered by train ' Trains.Titles(nTrig,:)], ChTitle,[],yscale, 3);
xTks = get(gca,'XTick') + T0;
set(gca,'XTickLabel',num2str(xTks(:)));
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
Axis1Flag = 'mTLFPs';


% --------------------------------------------------------------------
function EvaluateTriggeredMeanActivations_Callback(hObject, eventdata, handles)
global Args G Trains mTG
if isempty(G), 
    msgbox('No generators');
    return; 
end
if isempty(Trains),
    msgbox('No spike trains');
    return;
end
    
iLims = round(G.T0*Args.Fs) + [0 size(G.s,2)-1];
[id, nTrig, T0] = SelectTrigger(Trains, Args.Fs, iLims);
if isempty(id),
    uiwait(errordlg('No stimulus inside the activations.','warnign','modal'))
    return;
end
id = id - iLims(1) + 1;

[nSts, nPts] = size(id);
data = zeros(size(G.s,1), nPts);
for j = 1:nPts,
    data(:,j) = mean(G.s(:,id(:,j)),2);
end
mTG.data = data; mTG.T0 = T0; mTG.Trigger = nTrig; mTG.NumStimuli = nSts; 
PlotMeanTriggeredICs_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function PlotMeanTriggeredICs_Callback(hObject, eventdata, handles)
global Args Axis1Flag mTG
if isempty(mTG), 
    uiwait(errordlg('First Evaluate Triggered Mean Activations.','warning','modal'));
    return; 
end

axes(handles.axes1)
if ~strcmpi(Axis1Flag,'mTG')
    set(handles.Yscale,'String','auto');
    yscale = [];
    Tlim = mTG.T0 + [0 (size(mTG.data,2)-1)/Args.Fs];
else
    yscale = str2num(get(handles.Yscale,'String'));
    Tlim = get(handles.axes1,'Xlim');
end
set(handles.GeneratorGroup,'Visible','on');
idIN = intersect(1:size(mTG.data,1),str2num(get(handles.SelectedLoadings,'String')));
if isempty(idIN),
    uiwait(errordlg('No loadings selected.','warning','modal'));
    return;
end
mark = repmat('bgrcmyk',1,10); mark = mark(idIN);
GenTitles = ['s'*ones(length(idIN),1) num2str(idIN(:))];
GenTitles = mat2cell(GenTitles,ones(1,size(GenTitles,1)),size(GenTitles,2));
hold off; 
PlotEEG(mTG.data(idIN,:), Args.Fs, GenTitles, yscale,...
    ['mean (over ' num2str(mTG.NumStimuli) ' stimuli) activations triggered by train ' num2str(mTG.Trigger)], mTG.T0, mark)
xlim(Tlim)
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
Axis1Flag = 'mTG';


% --------------------------------------------------------------------
function CutTimeWindow_Callback(hObject, eventdata, handles)
global LFP Args Trains G
if isempty(LFP), return; end
uiwait(errordlg('This function does not work properly with generator sets except the first one! Recalculate them.',...
    'warning','modal'));
answ = inputdlg({'Select time window to drop (e.g. [10.4, 22.1]): '},'Input', 1);
if isempty(answ), return; end

iT = round(str2num(answ{1})*Args.Fs); iT = sort(iT(1:2));
iT(1) = max(iT(1),0); iT(2) = min(iT(2),size(LFP,2))-1;
LFP(:,1+(iT(1):iT(2))) = [];
if ~isempty(G),
    ii = iT - (round(G.T0*Args.Fs) - 1);
    ii(1) = max(ii(1),0); ii(2) = min(ii(2),size(G.s,2)-1);
    G.s(:,1 + (ii(1):ii(2))) = [];
    G.T0 = min(G.T0, (ii(1) + 1)/Args.Fs);
end
if isfield(Args,'ArtfctIDX'),
    sp = Args.ArtfctIDX;
    IDinside = sp > iT(1) & sp < iT(2);
    IDafter =  sp >= iT(2);
    sp(IDafter) = sp(IDafter) - (diff(iT) + 1);
    sp(IDinside) = [];
    Args.ArtfctIDX = sp; 
end
if ~isempty(Trains)
    for k = 1:length(Trains.Spikes)
        sp = Trains.Spikes{k};
        IDinside = sp > iT(1)/Args.Fs & sp < iT(2)/Args.Fs;
        IDafter =  sp >= iT(2)/Args.Fs;
        sp(IDafter) = sp(IDafter) - diff(iT)/Args.Fs;
        sp(IDinside) = [];
        Trains.Spikes{k} = sp;
    end
end
axes(handles.axes1)
PlotLFPs_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function EliminateLFPchannels_Callback(hObject, eventdata, handles)
global LFP
if isempty(LFP), return; end
nChns = size(LFP,1);
answ = inputdlg({'Eliminate channels (e.g. [1:5, 30:32]): '},'Input', 1);
if isempty(answ), return; end
DelChns = intersect(1:nChns,str2num(answ{1}));
LFP(DelChns,:) = [];
set(handles.StatusChannels,'String',['LFP Chans = ' num2str(size(LFP,1))])
PlotLFPs_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function SpectralFilter_Callback(hObject, eventdata, handles)
global LFP G Args Axis1Flag LFP_CA1
if isempty(LFP), return; end
answ = inputdlg({'Notch filter (Hz), e.g., [50, 100, 150]: ',...
    'Low Pass (Hz): ','High Pass (Hz): '},'Spectral Filtering',...
    1,{'[50 100]','',''});
if isempty(answ), return; end
FiletrBanc.Notch = str2num(answ{1});
FiletrBanc.LPF = str2num(answ{2});
FiletrBanc.HPF = str2num(answ{3});
switch Axis1Flag
    case 'LFPs'
        LFP = FilterLFPs(LFP, Args.Fs, FiletrBanc);
        uiwait(warndlg('LFPs have been filtered'));
        PlotLFPs_Callback(hObject, eventdata, handles)
    case 'CA1_LFPs'
        LFP_CA1 = FilterLFPs(LFP_CA1, Args.Fs, FiletrBanc);
        uiwait(warndlg('Virtual LFPs have been filtered'));
        PlotCA1LFPs_Callback(hObject, eventdata, handles)
    case 'G'
        if isempty(G) || isempty(G.s),
            beep;
            return;
        end
        G.s = FilterLFPs(G.s, Args.Fs, FiletrBanc);
        uiwait(warndlg('Generator''s activations have been filtered'));
        PlotGenerators_Callback(hObject, eventdata, handles);
end
        
        


% --------------------------------------------------------------------
function FourierSpectrum_Callback(hObject, eventdata, handles)
global Args

[X, chan] = SelectSignal(hObject, eventdata, handles);
if isempty(X), return; end
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2)
hold off; cla; set(handles.axes2,'Visible','off')
axes(handles.axes3)
cla; hold off; set(handles.axes3,'Visible','on')

[p, f] = periodogram(X,[],[],Args.Fs);

eval([get(handles.SetFrequencyBand,'Label') ';'])
idx = f >= Band(1) & f <= Band(2);
semilogy(log2(f(idx)), smooth(p(idx)), 'k','LineWidth',2)
grid on
xlim(log2(Band))
tks = 2.^get(gca,'XTick');
set(gca,'XTickLabel',num2str(tks(:),3));
title(['power spectral density for channel = ' num2str(chan)])
xlabel('frequency (Hz)')

axes(handles.axes4)
cla; hold off; set(handles.axes4,'Visible','on')
eval([get(handles.SetFreqBands,'Label') ';']);
nBands = size(FreqBands,1);
Eband = zeros(1,nBands);
for k = 1:nBands,
    iDx = find(f >= FreqBands(k,1) & f < FreqBands(k,2));
    if ~isempty(iDx)
        pLR = interp1(f,[0; p(2:end)],FreqBands(k,:),'pchip');
        pLR(pLR < 0 ) = 0;
        Eband(k) = trapz([FreqBands(k,1); f(iDx); FreqBands(k,2)],[pLR(1); p(iDx); pLR(2)]);
    end
end
if isfield(Args,'VoltDIM') && ~strcmpi(Args.VoltDIM,'mV'),
    Eband = 1e6*Eband;
end
bar(Eband)
% set(gca,'XTickLabel',{'delta','theta','alpha','beta','gamma'})
B = ['['*ones(nBands,1) num2str(FreqBands(:,1)) '-'*ones(nBands,1) num2str(FreqBands(:,2)) ones(nBands,1)*']Hz'];
set(gca,'XTickLabel', B)

title(['   Band power = [' num2str(Eband,3) ']  (mV^2)'])

set(handles.ChannelGroup,'Visible','on')
ButtonName = questdlg('Do you like to save the results in a file?', ...
                         'File question', ...
                         'Yes', 'No', 'No');
if strcmpi(ButtonName,'Yes')
    Eband = Eband(:);
    save('BandPower.txt','Eband','-ASCII')    
    f = f(idx);
    p = p(idx);
    p = smooth(p(:));
    idx = unique(round(linspace(1,length(f),5000)));
    Pow = [f(idx), p(idx)];
    save('PowerSpctr.txt','Pow','-ASCII')
    uiwait(msgbox(['The band data have been saved to: '  pwd filesep 'BandPower.txt; The power spectrum to: ' pwd filesep 'PowerSpctr.txt']));
end



% --------------------------------------------------------------------
function SetFrequencyBand_Callback(hObject, eventdata, handles)
answer = inputdlg({'Frequency limits (Hz):'}, 'input',1,{'[0.5 100]'});
if isempty(answer), return; end
set(handles.SetFrequencyBand,'Label',['Band = ' answer{1}])


% --------------------------------------------------------------------
function SetFreqBands_Callback(hObject, eventdata, handles)
answer = inputdlg({'Frequency bands (Hz) (delta, theta, alpha, beta, gamma):'},...
    'input',1,{'[0.5 4; 4 8; 8 13; 13 30; 30 100]'});
if isempty(answer), return; end
set(handles.SetFreqBands,'Label',['FreqBands = ' answer{1}])


% --------------------------------------------------------------------
function AutoCorrelation_Callback(hObject, eventdata, handles)
global Args
persistent answer

[X, chan] = SelectSignal(hObject, eventdata, handles);
if isempty(X), return; end
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2)
hold off; cla; set(handles.axes2,'Visible','off')
axes(handles.axes3)
cla; hold off; set(handles.axes3,'Visible','on')

if isempty(answer),  answer{1} = '500'; end
answer = inputdlg({'Maximal lag (ms):'},'input',1,answer);
if isempty(answer), return; end
mLag = round(Args.Fs*1e-3*str2num(answer{1}));
AC = xcorr(X, X, mLag, 'unbiased');
AC = AC((mLag + 1):end);
plot(1e3*(0:mLag)/Args.Fs,AC, 'b','LineWidth',2)
grid on
xlim([0 1e3*mLag/Args.Fs])
title(['auto correlation for channel = ' num2str(chan)])
xlabel('time (ms)')


% --------------------------------------------------------------------
function SignalPower_Callback(hObject, eventdata, handles)
persistent T
[X, chan, ArgsG] = SelectSignal(hObject, eventdata, handles);
if isempty(X), return; end
if isempty(T), T = {'1'}; end
T = inputdlg('Time window for the power estimate (s)','Input data',1,T);
if isempty(T{1}),  return; end
N = round(str2num(T{1})*ArgsG.Fs);
if N < 5,
    uiwait(msgbox('Too small window, cannot calculate!'));
    return;
end
Pow = smooth(X.^2, N);
axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','off')
axes(handles.axes4); cla; hold off;
set(handles.axes4,'Visible','off')
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2); cla; hold off;
axes(handles.axes2)
t = ArgsG.T0 + (0:length(Pow)-1)/ArgsG.Fs;
plot(t, Pow,'b','LineWidth',2); 
hold on
plot([t(1) t(end)], [0 0],'k:')
xlim([t(1) t(end)]);
ylm = get(gca,'YLim');
ylim(ylm(2)*[-0.3 1]);

title(['Signal power (in [V^2]) for channel ' num2str(chan) '; moving window = ' num2str(T{1}) ' s'])
set(handles.axes2,'Visible','on')
switch  ArgsG.Type
    case 'LFP'
        title(['DC+AC power for LFP chan ' num2str(chan) '  in [' ArgsG.VoltDIM '^2]; moving window = ' num2str(T{1}) ' s'])
    case 'CA1_LFP'
        title(['DC+AC power for Virtual LFP chan ' num2str(chan) '  in [' ArgsG.VoltDIM '^2]; moving window = ' num2str(T{1}) ' s'])
    case 'G'
        title(['DC+AC power for IC' num2str(chan) '  in [a.u.]; moving window = ' num2str(T{1}) ' s'])
end        

% --------------------------------------------------------------------
function MeanPowerWindow_Callback(hObject, eventdata, handles)

[X1, chan1, ArgsG] = SelectSignal(hObject, eventdata, handles);
Pow1 = sum(X1.^2)/length(X1);
Chans = str2num(get(handles.ChannelSelector,'String'));
N = length(Chans);
Pow = zeros(1,N);
for k = 1:N,
    set(handles.ChannelSelector,'Value',k);
    Xtmp = SelectSignal(hObject, eventdata, handles);
    Pow(k) = sum(Xtmp.^2)/length(Xtmp);
end
set(handles.ChannelSelector,'Value',chan1);
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')
axes(handles.axes3); cla; hold off;
axes(handles.axes3)
set(handles.axes3,'Visible','on')
bar(Pow)
xlim([1 N]);
ylm = get(gca,'YLim');
ylim(ylm(2)*[-0.1 1]);
switch  ArgsG.Type
    case 'LFP'
        title(['DC+AC power for LFP chan ' num2str(chan1) ' is ' num2str(Pow1,3) ' [' ArgsG.VoltDIM '^2]'])
    case 'CA1_LFP'
        title(['DC+AC power for Virtual LFP chan ' num2str(chan1) ' is ' num2str(Pow1,3) ' [' ArgsG.VoltDIM '^2]'])
    case 'G'
        title(['DC+AC power for IC' num2str(chan1) ' is ' num2str(Pow1,3) ' [a.u.]'])
end
ButtonName = questdlg('Do you like to save the results in a file?', ...
                         'File question', ...
                         'Yes', 'No', 'No');
if strcmpi(ButtonName,'Yes')
    Pow = Pow(:);
    save('MeanPower.txt','Pow','-ASCII') 
    uiwait(msgbox(['The data have been saved to: '  pwd filesep 'MeanPower.txt']));
end




% --------------------------------------------------------------------
function MeanPowerWithoutDC_Callback(hObject, eventdata, handles)
[X1, chan1, ArgsG] = SelectSignal(hObject, eventdata, handles);
Pow1 = sum((X1 - mean(X1)).^2)/length(X1);
Chans = str2num(get(handles.ChannelSelector,'String'));
N = length(Chans);
Pow = zeros(1,N);
for k = 1:N,
    set(handles.ChannelSelector,'Value',k);
    Xtmp = SelectSignal(hObject, eventdata, handles);
    Pow(k) = sum((Xtmp - mean(Xtmp)).^2)/length(Xtmp);
end
set(handles.ChannelSelector,'Value',chan1);
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')
axes(handles.axes3); cla; hold off;
axes(handles.axes3)
set(handles.axes3,'Visible','on')
bar(Pow)
xlim([1 N]);
ylm = get(gca,'YLim');
ylim(ylm(2)*[-0.1 1]);
switch  ArgsG.Type
    case 'LFP'
        title(['AC power for LFP chan ' num2str(chan1) ' is ' num2str(Pow1,3) ' [' ArgsG.VoltDIM '^2]'])
    case 'CA1_LFP'
        title(['AC power for Virtual LFP chan ' num2str(chan1) ' is ' num2str(Pow1,3) ' [' ArgsG.VoltDIM '^2]'])
    case 'G'
        title(['AC power for IC' num2str(chan1) ' is ' num2str(Pow1,3) ' [a.u.]'])
end        


% --------------------------------------------------------------------
function CopyOriginalLFPstoReconstructedLFPs_Callback(hObject, eventdata, handles)
global Args LFP LFP_CA1
if isempty(LFP), beep; return; end
nChs = size(LFP,1);
Chs = inputdlg({'Channels to copy (e.g. [1,3:5])'},'detrending',1,{['[1:' num2str(nChs) ']']});
if isempty(Chs) || isempty(Chs{1}), return; end
Chns = intersect(str2num(Chs{1}),1:nChs);
if isempty(Chns), return; end
LFP_CA1 = LFP(Chns,:);
Args.CA1 = Chns;
set(handles.ElectrodeRange,'String',['[' num2str(Chns(1)) ':' num2str(Chns(end)) ']']);
PlotCA1LFPs_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function CopyVirtualToOriginal_Callback(hObject, eventdata, handles)
global LFP LFP_CA1
if isempty(LFP_CA1), return; end
LFP = LFP_CA1;
set(handles.ElectrodeRange,'String',['[1:' num2str(size(LFP,1)) ']']);
PlotLFPs_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function NormalizeGenByBAmpli_Callback(hObject, eventdata, handles)
global G
if isempty(G), beep; return; end

alpha = max(abs(G.V));

K = ones(size(G.V,1),1)*alpha; 
G.V = G.V./K;
G.s = (alpha'*ones(1,size(G.s,2))).*G.s; 

set(handles.SelectedLoadings,'String',num2str(G.ID));
set(handles.Yscale,'String','auto')
PlotGenerators_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function NormGenBySstd_Callback(hObject, eventdata, handles)
global G
if isempty(G), return; end

alpha = std(G.s,[],2);

G.V = G.V.*(ones(size(G.V,1),1)*alpha');
G.s = G.s./(alpha*ones(1,size(G.s,2))); 

set(handles.SelectedLoadings,'String',num2str(G.ID));
set(handles.Yscale,'String','auto')
PlotGenerators_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function CSD_Deriv5_Callback(hObject, eventdata, handles)
set(handles.CSD_Deriv5,'Checked','on');
set(handles.CSD_Deriv3,'Checked','off')


% --------------------------------------------------------------------
function CSD_Deriv3_Callback(hObject, eventdata, handles)
set(handles.CSD_Deriv5,'Checked','off');
set(handles.CSD_Deriv3,'Checked','on')


% --------------------------------------------------------------------
function PowerLinearCorrCoeff_Callback(hObject, eventdata, handles)
persistent DefAnsw
if isempty(DefAnsw), DefAnsw = {'1',''}; end
DefAnsw = inputdlg({'Time window for the power estimate (s)','Channel pair (e.g. [1 5]):'},...
    'Input data',1,DefAnsw);
if isempty(DefAnsw),
    beep
    return; 
end
if isempty(DefAnsw{2}),  return; end
Chans = str2num(DefAnsw{2});
[X, chan, ArgsG] = SelectSignal(hObject, eventdata, handles, Chans);
if length(chan) ~= 2,
    uiwait(errordlg('Wrong channels selected'));
    return;
end
if isempty(X), return; end
N = round(str2num(DefAnsw{1})*ArgsG.Fs);
if N < 5,
    uiwait(msgbox('Too small window, cannot calculate!'));
    return;
end

Pow = zeros(size(X));
Pow(1,:) = smooth(X(1,:).^2, N);
Pow(2,:) = smooth(X(2,:).^2, N);
axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','off')
axes(handles.axes4); cla; hold off;
set(handles.axes4,'Visible','off')
set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
axes(handles.axes2); cla; hold off;
axes(handles.axes2)
clr = 'bgrcmyk';
icl = mod(chan - 1,7)+1;
t = ArgsG.T0 + (0:size(Pow,2)-1)/ArgsG.Fs;
plot(t, Pow(1,:),clr(icl(1)),'LineWidth',2); 
hold on
plot(t, Pow(2,:),clr(icl(2)),'LineWidth',2); 
plot([t(1) t(end)], [0 0],'k:')
xlim([t(1) t(end)]);
ylm = get(gca,'YLim');
ylim(ylm(2)*[-0.3 1]);


Pow = detrend(Pow','constant')';
sx = sqrt(sum(Pow.^2,2));
sxy = sum(Pow(1,:).*Pow(2,:));
r = sxy/(sx(1)*sx(2));

set(handles.axes2,'Visible','on')
switch  ArgsG.Type
    case 'LFP'
        title(['DC+AC power for LFP chan ' num2str(chan) ' (in [V^2]); moving window = ' DefAnsw{1} ' s; r = ' num2str(r)])
    case 'CA1_LFP'
        title(['DC+AC power for Virtual LFP chan ' num2str(chan) ' (in [V^2]); moving window = ' DefAnsw{1} ' s; r = ' num2str(r)])
    case 'G'
        title(['DC+AC power for IC ' num2str(chan) ' (in [a.u.]); moving window = ' DefAnsw{1} ' s; r = ' num2str(r)])
end        


% --------------------------------------------------------------------
function ConvolveGaussainKernel_Callback(hObject, eventdata, handles)
global G LFP Args Trains Axis1Flag
if isempty(Trains), beep; return; end
persistent DefAnsw

SpTtl = Trains.Titles;
if isempty(DefAnsw), DefAnsw = {SpTtl(1,:),'P8','100','0','0'}; end
DefAnsw = inputdlg({'SELECT TRAIN TO CORRELATE',...
    'WITH (L12 or L2:9 for Lfp; P3 for lfp''s Power; G1:4 for Generators; W4 for Gen''s poWer)',...
    'Kernel width (ms)','Number of Surrogate Trains (0 - no surrogate test)',...
    'Time Shift of the Train (ms)'}, 'Input data',1,DefAnsw);
if isempty(DefAnsw),  return; end
idTr = find(1==strcmpi(DefAnsw{1},mat2cell(SpTtl,ones(1,size(SpTtl,1)),size(SpTtl,2))));
if isempty(idTr)
    beep
    uiwait(errordlg('No such train'))
    return
end
Tlim = get(handles.axes1, 'Xlim');



% Make Kernel
sigma = round(1e-3*Args.Fs*str2num(DefAnsw{3})/2);
K = normpdf(-4*sigma:4*sigma, 0, sigma);

% Select signals to correlate with the train
Ans = DefAnsw{2};
idCh = str2num(Ans(2:end));
switch Ans(1) 
    case 'L' % correlation with LFPs
        idCh = intersect(1:size(LFP,1), idCh);
        if isempty(idCh)
            beep;
            uiwait(errordlg('Incorrect LFP channels!'));
            return;
        end
        id = round(Args.Fs*(Tlim - Args.T0)); id(1) = max(id(1),1); id(2) = min(id(2),size(LFP,2));
        Y = LFP(idCh,id(1):id(2));
    case 'P' % correlation with LFP power
        idCh = intersect(1:size(LFP,1),idCh);
        if isempty(idCh)
            beep;
            uiwait(errordlg('Incorrect LFP channels!'));
            return;
        end
        id = round(Args.Fs*(Tlim - Args.T0)); id(1) = max(id(1),1); id(2) = min(id(2),size(LFP,2));
        Y = zeros(length(idCh),diff(id) + 1);
        for k = 1:length(idCh),
            Y(k,:) = conv(LFP(idCh(k),id(1):id(2)).^2, K, 'same');
        end
    case 'G' % correlation with Generators
        if isempty(G)
            beep;
            uiwait(errordlg('There is no generators!'));
            return;
        end            
        idCh = intersect(1:size(G.s,1), idCh);
        if isempty(idCh)
            beep;
            uiwait(errordlg('Incorrect generators!'));
            return;
        end
        if Tlim(1) < G.T0, Tlim(1) = G.T0; end
        id = round(Args.Fs*(Tlim - G.T0)); 
        id(1) = max(id(1),1); id(2) = min(id(2),size(G.s,2));
        Y = G.s(idCh,id(1):id(2));
    case 'W' % correlation with Generator's power
        if isempty(G)
            beep;
            uiwait(errordlg('There is no generators!'));
            return;
        end            
        idCh = intersect(1:size(G.s,1), idCh);
        if isempty(idCh)
            beep;
            uiwait(errordlg('Incorrect generators!'));
            return;
        end
        if Tlim(1) < G.T0, Tlim(1) = G.T0; end
        id = round(Args.Fs*(Tlim - G.T0)); 
        id(1) = max(id(1),1); id(2) = min(id(2),size(G.s,2));
        Y = G.s(idCh,id(1):id(2)).^2;
        for k = 1:size(Y,1),
            Y(k,:) = conv(Y(k,:).^2, K, 'same');
        end        
    otherwise
        beep;
        uiwait(errordlg('Invalid element for correlation'))
        return;
end

% Convolve train with gaussian kernel
Train = Trains.Spikes{idTr} + 1e-3*str2num(DefAnsw{5});
w = str2num(DefAnsw{3});
X = ConvolveTrainWithGaussianKernel(Train, Tlim, w, Args.Fs);


% Cut the tail if necessary
Lmax = min(size(Y,2), size(X,2));
Y = Y(:,1:Lmax);
X = X(1:Lmax);
Tlim(2) = Tlim(1) + Lmax/Args.Fs;


% Evaluate the correlation coefficient
r = corrcoef([X; Y]'); r = r(1,2:end);

% Surrogate test
nSurr = str2num(DefAnsw{4});
if nSurr == 0,
    Rsrr = 0;
elseif nSurr < 20,
    beep
    uiwait(errordlg('The surrogate test is too weak, Increase the number of surrogates!'))
    Rsrr = 0;
else
    Tsurr = SurrogateSpikeTrains(Train, nSurr, Tlim);
    Tsurr = Args.Fs*(cell2mat(Tsurr) - Tlim(1));
    Rsrr = DoTheSurrogateTest(Y, Tsurr, w*Args.Fs);
end

% Make a plot
if size(Y,1) == 1
    Y = Y/std(Y);
    X = X/std(X);
    axes(handles.axes3); cla; hold off;
    set(handles.axes3,'Visible','off')
    axes(handles.axes4); cla; hold off;
    set(handles.axes4,'Visible','off')
    axes(handles.axes2); cla; hold off;
    set(handles.axes2,'Visible','on')
    t = Tlim(1) + (0:size(X,2)-1)/Args.Fs;
    plot(t, Y, 'b'); hold on; plot(t, X, 'r','LineWidth',2);
    if Rsrr == 0,
        title(['red - Spike rate in ' SpTtl(idTr,:) ', blue - ' Ans '; r = ' num2str(r,3) ' (no surrogate test)'])
    else
        title(['red - Spike rate in ' SpTtl(idTr,:) ', blue - ' Ans '; r = ' num2str(r,3) ' Rsurr = [' num2str(Rsrr) ']'])
    end        
    xlim(Tlim)
else
    axes(handles.axes2); cla; hold off;
    set(handles.axes2,'Visible','off')
    axes(handles.axes3); cla; hold off;
    set(handles.axes3,'Visible','on')
    bar(idCh, r); 
    hold on
    plot(idCh, Rsrr,'r+','MarkerSize',8,'MarkerFacecolor','r')
    axis([idCh(1)-0.5, idCh(end)+0.5, -1, 1])
    if max(r) < 0.01,
        title(['Correlation of spike rate in ' SpTtl(idTr,:) ' with ' Ans ' IS TOO LOW!'])
    else
        title(['Correlation of spike rate in ' SpTtl(idTr,:) ' with ' Ans])
    end
end


% --------------------------------------------------------------------
function EvaluateSpikeTriggeredMean_Callback(hObject, eventdata, handles)
global G LFP LFP_CA1 Args Trains Axis1Flag
persistent answ
if isempty(Trains), beep; return; end
if ~any(strcmpi(Axis1Flag,{'G','LFPs','CA1_LFPs'})), 
    beep; 
    uiwait(errordlg('Select LFP, virtual LFPs or Generator''s plot'));
    return; 
end


if isempty(answ),
    answ = {Trains.Titles(1,:),'1','[-5 50]','yes;  0','auto','0','auto; 19',''};
end
answ = inputdlg({['Trigger (available from: ' Trains.Titles(1,:) ' to '...
    Trains.Titles(end,:) ')'], 'Channels (LFPs or Generators) to process (e.g. [2:14])',...
    'Time interval (ms):','Remove DC at certian instant in ms (e.g.   yes; -10):','Y-scale:',...
    'Number of surrogates (at least few hundreds):',...
    'Parameters for CSD drawing: color limit; number of colors (e.g.  1e-3; 5)','Output file name:'},'Input', 1, answ);
if isempty(answ), beep; return; end
[dum,nTrig] =  intersect(str2num(Trains.Titles),str2num(answ{1}));
if isempty(dum), 
    uiwait(errordlg('No such trigger exists.')); 
    return
end
Tlim = get(handles.axes1, 'Xlim');



switch Axis1Flag
    case 'LFPs'
        OBJ = 'LFP';
        T0 = Args.T0;
        nChns =  intersect(1:size(LFP,1), str2num(answ{2}));
        ttl = [ones(length(nChns),1)*'e' num2str(nChns(:))];
        ttl = mat2cell(ttl,ones(1,size(ttl,1)),size(ttl,2));
        ttl2 = ['Spike (chan. ' answ{1} ') Triggered Mean of LFPs;  T = ['...
            num2str(Tlim(1),3) ', ' num2str(Tlim(2),3) '] s' ];
    case 'CA1_LFPs'
        OBJ = 'LFP_CA1';
        T0 = Args.T0;
        nChns =  intersect(1:size(LFP_CA1,1), str2num(answ{2}));
        ttl = [ones(length(nChns),1)*'e' num2str(nChns(:))];
        ttl = mat2cell(ttl,ones(1,size(ttl,1)),size(ttl,2));
        ttl2 = ['Per spike (chan. ' answ{1} ') triggered mean of LFPs;  T = ['...
            num2str(Tlim(1),3) ', ' num2str(Tlim(2),3) '] s' ];
    case 'G'
        OBJ = 'G.s';
        T0 = G.T0;
        nChns =  intersect(1:size(G.s,1), str2num(answ{2}));
        ttl = [ones(length(nChns),1)*'G' num2str(nChns(:))];
        ttl = mat2cell(ttl,ones(1,size(ttl,1)),size(ttl,2));
        ttl2 = ['Per spike (chan. ' answ{1} ') triggered mean of generators;  T = ['...
            num2str(Tlim(1),3) ', ' num2str(Tlim(2),3) '] s' ];
end

Tlim(1) = max(Tlim(1), T0);
id = 1 + round((Tlim-T0)*Args.Fs); 

Y = eval([OBJ '(nChns,id(1):end)']); 
idEnd = min(size(Y,2), 1 + diff(id));
Y = Y(:,1:idEnd);


Spikes = Trains.Spikes{nTrig} - Tlim(1);
Spikes(Spikes < 0) = []; 
Spikes(Spikes > diff(Tlim)) = [];
if length(Spikes) < 1 
    beep;
    uiwait(errordlg('No Spikes in the current time window.')); 
    return; 
end
Spikes = round(Spikes*Args.Fs) + 1;


dW = str2num(answ{3});
T = round(dW*1e-3*Args.Fs);
T = T(1):T(2);
nSps = length(Spikes);
idx = Spikes(:)*ones(1,length(T)) + ones(nSps,1)*T;
idx(idx < 1) = 1;
idx(idx > size(Y,2)) = size(Y,2);
mY = Y(:,idx(1,:));
for k = 2:nSps,
    mY = mY + Y(:,idx(k,:));
end
mY = mY/nSps;


nSurr = str2num(answ{6});
sLimits = [];
if nSurr > 0,
    if nSurr >= 200,
        if size(Y,1) == 1
            alpha = 0.1;
            [sLimits, mu] = NivelConfianzaBarajado(nSurr, Spikes, Y, T, alpha);
        else
            uiwait(errordlg('The surrogate test for multiple signals is NOT implemented yet!'));
        end
    else
        uiwait(errordlg('Use at least 200 surrogates!'));
    end
end

if ~isempty(strfind(answ{4}, 'yes'))
    idsep = strfind(answ{4}, ';');
    if ~isempty(idsep)
        Tdc = Args.Fs*1e-3*str2num(answ{4}(idsep+1:end));
        id0 = find((T(1:end-1)-Tdc).*(T(2:end)-Tdc) <= 0, 1); if isempty(id0), id0 = 1; end
        mY = mY - mY(:,id0)*ones(1,size(mY,2));
        if ~isempty(sLimits),
            sLimits = sLimits - mu;
        end
    end
end

axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')

axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','on')
if strcmpi(answ{4},'auto')
    scl = [];
else
    scl = str2num(answ{5});
end
PlotEEG(mY, 1e-3*Args.Fs, ttl, scl, ttl2, dW(1),'bgrcmyk')
hold on
ylm = get(gca,'YLim');
plot([0 0], ylm, 'r--')
if ~isempty(sLimits)
    plot(dW,sLimits(1)*[1 1],'k:')
    plot(dW,sLimits(2)*[1 1],'k:')
end
xlabel('time (ms)')


if size(mY,1) > 3,
    axes(handles.axes4); cla; hold off;
    set(handles.axes4,'Visible','on')
    if strcmpi(get(handles.CSD_Deriv5,'Checked'),'on')
        Type2deriv = '2improved';
        titl = 'CSD 5 pnts differences';
    else
        Type2deriv = '2simple';
        titl = 'CSD 3 pnts differences';
    end
    set(gca,'Xlim', dW);
    
    idsep = strfind(answ{7}, ';');
    if isempty(idsep)
        CLims = 'auto';
        NCls = 20;
    else
        CLims = str2num(answ{7}(1:idsep-1));
        if isempty(CLims)
            CLims = 'auto';
        else
            CLims = num2str(CLims(1));
        end
        NCls = str2num(answ{7}(idsep+1:end));
        if isempty(NCls)
            NCls = '20';
        else
            NCls = num2str(NCls+1);
        end
    end
            
    
    titl = [titl '; DC removed: ' answ{4} ' (ms)'];
    ComputeAndDrawCSD({CLims, NCls,'no'}, Args.Fs*1e-3, dW(1), [nChns; 1:size(mY,1)], mY, [], Type2deriv);
    title(titl);
    xlabel('time (ms)')
end



if ~isempty(answ{8})
    DATOS = mY';
    save(answ{8},'DATOS','-ASCII')
    uiwait(msgbox(['Results have been saved to: ' pwd filesep answ{8} ]));
end



% --------------------------------------------------------------------
function SpikeCrossCorrelation_Callback(hObject, eventdata, handles)
global Trains  Axis1Flag 
persistent answ

if ~strcmpi(Axis1Flag,'Trains')
    beep
    uiwait(errordlg('Plot spike trains first and select the time interval for the analysis.'));
    return
end

if isempty(Trains),
    beep
    uiwait(errordlg('No spike trains available.'));
    return; 
end
if isempty(answ),
    answ = {Trains.Titles(1,:),Trains.Titles(end,:),'[-5 50]','100','no'};
end
answ = inputdlg({['Trigger (available from: ' Trains.Titles(1,:) ' to '...
    Trains.Titles(end,:) ')'], 'Channel','Time interval (ms):','Number of bins','Delete zero bin'},'Enter parameters', 1, answ);
if isempty(answ), beep; return; end
[dum,nTrig] =  intersect(str2num(Trains.Titles),str2num(answ{1}));
[dum,nChan] =  intersect(str2num(Trains.Titles),str2num(answ{2}));
if isempty(nTrig) || isempty(nChan), 
    beep
    uiwait(errordlg('Check parameters!')); 
    return
end

Tlim = str2num(answ{3});
nBins = str2num(answ{4});
n = Trains.Spikes{nChan};
t = Trains.Spikes{nTrig};
Wlim = get(handles.axes1, 'Xlim');

n(n < Wlim(1)) = [];
n(n > Wlim(2)) = [];
t(t < Wlim(1)) = [];
t(t > Wlim(2)) = [];

if isempty(n) || isempty(t), 
    beep
    uiwait(errordlg('Check time window!')); 
    return
end
if strcmpi(answ{5},'no')
    FlagZero = 0;
else
    FlagZero = 1;
end    

[h, f] = PSTH(n, t, 1e-3*Tlim, nBins, FlagZero);


axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')
axes(handles.axes4); cla; hold off;
set(handles.axes4,'Visible','on')
bar(f*1e3, h)
xlim(Tlim)
xlabel('time lag (ms)')
ylabel('counts')
title(['Spike crosscorrelation (' Trains.Titles(nTrig,:) ' - trigger; ' Trains.Titles(nChan,:) ' - channel)'])


% --------------------------------------------------------------------
function ICA_secuential_Callback(hObject, eventdata, handles)
global Args LFP G LFP_CA1 Axis1Flag  GnrsSet
persistent answ
if isempty(LFP), beep; return; end


xlm = get(handles.axes1,'Xlim');

if strcmpi(get(handles.DefineNDIM, 'Checked'),'on')
    eval([get(handles.DefineNDIM,'Label') ';']);
else
    NDIM = 'auto';
end
if strcmpi(get(handles.ExtendedICA,'Checked'),'off')
    ExtFlag = 0;
else
    ExtFlag = 1;
end    

if isempty(answ),
    answ = {'5','0.4','10'};
end
answ = inputdlg({'Time interval (s):', 'Threshold for clustering',...
    'Min percentage in cluster'},'Enter parameters', 1, answ);
if isempty(answ), beep; return; end

h = msgbox('ICA of LFPs, don''t press any key, JUST WAIT!');

tt = round(Args.Fs*(xlm - Args.T0));
if tt(1) < 1, tt(1) = 1; xlm(1) = Args.T0; end
tt(2) = min(tt(2),size(LFP,2));
dt = round(Args.Fs*(str2num(answ{1})));
NW = floor((tt(2)-tt(1))/dt)+1;
ttt = round(linspace(tt(1),tt(2),NW));
switch Axis1Flag
    case 'LFPs'
        if ~isnumeric(NDIM) || NDIM > rank(LFP(:,tt(1):tt(2)))
            NDIM = rank(LFP(:,tt(1):tt(2)));
        end
        for n = 1:(NW-1)
            [A, s, niters, idIN] = ICA_1(LFP(:,ttt(n):ttt(n+1)), NDIM, 'off', ExtFlag);
            Vset{n} = A;
        end
end
[D, mV, DinterCluster] = ClusterMultiLoadings(Vset, str2num(answ{2}), 0.01*str2num(answ{3}));

set(handles.Status,'String',['Current NDIM = ' num2str(NDIM)]);
close(h)

axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')
axes(handles.axes4); cla; hold off;
set(handles.axes4,'Visible','on')
[nCs, nWs] = size(D);
DD = ones(2*nCs + 1, nWs);
DD(2*(1:nCs),:) = D;
imagesc((ttt(2:end) - 0.5*(ttt(2)-ttt(1)))/Args.Fs, (0.5:0.5:(nCs+0.5)), DD, [0 1]);
colorbar
xlabel('time (s)')
ylabel('cluster')
title('intra-cluster distances')
set(gca,'YTick',1:nCs)

axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','on')
PlotLoadings(mV, [], 1:min(6,size(mV,2)),[],[])
title('voltage loadings (mean over cluster)')


% --------------------------------------------------------------------
function RUNICA_Callback(hObject, eventdata, handles)
set(handles.ExtendedICA,'Checked','off')
set(handles.RUNICA,'Checked','on')
set(handles.FASTICA,'Checked','off')
set(handles.KDICA,'Checked','off')


% --------------------------------------------------------------------
function FASTICA_Callback(hObject, eventdata, handles)
set(handles.ExtendedICA,'Checked','off')
set(handles.RUNICA,'Checked','off')
set(handles.FASTICA,'Checked','on')
set(handles.KDICA,'Checked','off')

% --------------------------------------------------------------------
function ExtendedICA_Callback(hObject, eventdata, handles)
set(handles.ExtendedICA,'Checked','on')
set(handles.RUNICA,'Checked','off')
set(handles.FASTICA,'Checked','off')
set(handles.KDICA,'Checked','off')

% --------------------------------------------------------------------
function KDICA_Callback(hObject, eventdata, handles)
set(handles.ExtendedICA,'Checked','off')
set(handles.RUNICA,'Checked','off')
set(handles.FASTICA,'Checked','off')
set(handles.KDICA,'Checked','on')

% --------------------------------------------------------------------
function AUTO_Threshold_Callback(hObject, eventdata, handles)
answer = inputdlg({'Threshold for NDIM (retained variance in %)'}, 'Define NDIM threshold',1);
if isempty(answer), return; end
set(handles.AUTO_Threshold,'Label',['Threshold (AUTO) = ' num2str(answer{1}) '%'])


% --------------------------------------------------------------------
function LFPClassifier_Callback(hObject, eventdata, handles)
global Args LFP G LFP_CA1 Axis1Flag  GnrsSet
persistent answ
if isempty(LFP), beep; return; end

if isempty(answ),
    answ = {'[6 21 27]','10'};
end
answ = inputdlg({'Representative channels (Cx, CA1, DG):', 'Time window for spectrum estimate (s)'},...
    'Enter parameters', 1, answ);
if isempty(answ), beep; return; end

channs = intersect(str2num(answ{1}),1:size(LFP,1));
tW = round(str2num(answ{2})*Args.Fs);
eval([get(handles.SetFreqBands,'Label') ';']);
nBands = size(FreqBands,1);
nChans = length(channs);


t1 = unique(round(linspace(0,size(LFP,2) - tW,1000)));
Eband = zeros(nBands*nChans,length(t1));
h = waitbar(0,'Calculating, please wait...');
if isfield(Args,'VoltDIM') && strcmpi(Args.VoltDIM,'mV'),
    C = 1;
else
    C = 1e6;
end
for ii = 1:length(t1),
    for jj = 1:nChans,
        [p, f] = periodogram(LFP(channs(jj),t1(ii) + (1:tW)), [], [], Args.Fs);
        for k = 1:nBands,
            iDx = f >= FreqBands(k,1) & f < FreqBands(k,2);
            Eband(k + nBands*(jj - 1),ii) = C*trapz(f(iDx),p(iDx));
        end
    end
    waitbar(ii/length(t1));
end
close(h)

axes(handles.axes1)
hold off; cla; 
R1 = Eband(1 +(0:nChans-1)*nBands,:)./Eband(2 +(0:nChans-1)*nBands,:);
R2 = Eband(1 +(0:nChans-1)*nBands,:)./Eband(nBands +(0:nChans-1)*nBands,:);
rMax =  max([max(R1,[],2) max(R2,[],2)],[],2);

for k = 1:nChans,
    area((tW/2 + t1)/Args.Fs, nChans - k + R2(k,:)/rMax(k), nChans - k,'FaceColor','r')
    hold on
    area((tW/2 + t1)/Args.Fs, nChans - k + R1(k,:)/rMax(k), nChans - k, 'FaceColor','b')
    plot((tW/2 + t1)/Args.Fs, nChans - k + R1(k,:)/rMax(k), 'b','LineWidth',2)
    plot((tW/2 + t1)/Args.Fs, nChans - k + R2(k,:)/rMax(k), 'r','LineWidth',2)
end
axis([0 (t1(end) + tW)/Args.Fs 0 nChans])
set(gca,'YTick',(1:nChans)-1)
TTL = {'DG','CA1','CX'};
set(gca,'YTickLabel',TTL(1:nChans))
title(['Ratios: BLUE - Delta/Theta, RED - Delta/Gamma; Vertical scales (from TOP to BOTTOM): [' num2str(rMax',4) ']'])
xlabel('time (s)')
grid on

axes(handles.axes3)
cla; hold off; set(handles.axes3,'Visible','off')
axes(handles.axes4)
cla; hold off; set(handles.axes4,'Visible','off')
axes(handles.axes2)
hold off; cla; set(handles.axes2,'Visible','on')

Emax = 0.6*max(Eband(:));
cls = 'bgrcmyk';
for k = 1:nBands,
    EbandMean = mean(Eband(k:nBands:end,:),1);
    area((tW/2 + t1)/Args.Fs, Emax*k + EbandMean, Emax*k, 'FaceColor',cls(k))
    hold on
end
axis([0 (t1(end) + tW)/Args.Fs Emax (nBands+1)*Emax])
set(gca,'YTick',Emax*(1:nBands))
set(gca,'YTickLabel',{'Delta','Theta','Alpha','Beta','Gamma'})
title(['Mean (over selected channels) band power ('  num2str(tW/Args.Fs) 's moving window); Vertical scale = '...
    num2str(Emax,3) ' mV^2'])
grid on


ButtonName = questdlg('Do you like to save the results in a file?', ...
                         'File question', ...
                         'Yes', 'No', 'No');
if strcmpi(ButtonName,'Yes')
    FS = [(tW/2 + t1(:))/Args.Fs, Eband'];
    TTL = '\t t \t CXdelta \t CXtheta \t CXalpha \t CXbeta \t CXgamma \t CA1delta \t CA1theta \t CA1alpha \t CA1beta \t CA1gamma \t DGdelta \t DGtheta \t DGalpha \t DGbeta \t DGgamma\n';
    FN = 'DynamicsOfBandPower.txt';
    fid = fopen(FN, 'w');
    fprintf(fid, TTL,'%s\n');
    fclose(fid);
    save(FN,'FS','-ASCII', '-append')    
    uiwait(msgbox(['The data have been saved to: '  pwd filesep 'DynamicsOfBandPower.txt']));
end


% --------------------------------------------------------------------
function SortSpikes_Callback(hObject, eventdata, handles)
global Args LFP Axis1Flag Trains
persistent answ
if isempty(LFP), beep; return; end
if ~isfield(Args,'ElctrArrangement') || isempty(Args.ElctrArrangement)
    ButtonName = questdlg('Did you previously arrange the electrodes?','Arrangement is required','Yes, proceed','Cancel','Yes, proceed');
    if strcmpi(ButtonName,'cancel')
        return;
    end
end    

if ~isempty(Trains)
    n1 = length(Trains.Spikes);
    [n2,n3] = size(Trains.Titles);
    if n1 ~= n2 || n3 ~= 2,
        answer = questdlg('Your spike trains have problems. Fixed?',...
            'Problem with trains','yes','no','yes');
        if strcmpi(answer,'yes')
            TrTitles = [];
            for k = 1:n1,
                TrTitles = [TrTitles; num2str(k,'%2.2d')];
            end
            Trains.Titles = TrTitles;
            uiwait(msgbox([num2str(n1) ' trains are included.']))
        end
    end
end


if isempty(answ),
    answ = {'','WSAC','6','[-0.5 2]','0.3',''};
end

answ = inputdlg({'Channel with spikes (the first and the last channels cannot be used!):',...
    'Sorting method (either WSAC or PCA):',...
    'Threshold for spike detection (multiplyer):',...
    'Time window for spikes (in ms):',...
    'Maximal time shift for allignment of spikes (in ms):',...
    'Subtract trains (eliminate spikes that coincide with spikes of these trains)'},'select channel', 1, answ);
if isempty(answ) || isempty(answ{1}) || isempty(str2num(answ{1})),
    uiwait(msgbox('No channel has been selected'));
    return
end
Chan = str2num(answ{1});
Chan = intersect(1:size(LFP,1),Chan);
if length(Chan) ~= 1,
    uiwait(msgbox('Wrong channel has been selected'));
    return
end     
if Chan == 1 || Chan == size(LFP,1),
    uiwait(msgbox('In the current version the first and the last channels cannot be used!'));
    return
end  
Method = answ{2};
alpha = str2num(answ{3}); % Threshold multiplyer
if isempty(alpha),
    alpha = 6;  
end
W = str2num(answ{4}); % window for spikes
if length(W) ~= 2 ,
    W = [-0.5 2.0]; 
end
TS = str2num(answ{5}); % the maximal time shift for allignment
if length(TS) ~= 1 ,
    TS = 0.3; 
end

s = -diff(LFP(Chan + (-1:1),:), 2, 1); % Calculate CSD of spikes
Tsp = DetectSpikeTimes(s, Args.Fs, alpha); % Detection of Spike Times
if isempty(Tsp), 
    uiwait(msgbox('No spikes have been found in this channel'));
    return;
end

% Eliminate detected spikes that coinsides with spikes from selected trains
Tsp = SubtractTrainsFormDetectedSpikes(Tsp, Trains, answ{6}, Args.Fs); 



[WF, Tsp] = ExtractSpikeWaveForms(s, Tsp, round([W TS]*1e-3*Args.Fs));% Select spike WaveForms and interpolate

axes(handles.axes2)
hold off; cla; set(handles.axes2,'Visible','off')
switch Method
    case 'WSAC'
        rWF = FindRepresentativeWaveForms(WF, handles); % Interactively find representative WFs
        mScale = 80;
        WTname = 'haar';
        WTC = CalculateWTofSpikes(rWF, WF, s(1:min(length(s),10*Args.Fs)), mScale, WTname);% Wavelet Sorting
    case 'PCA'
        [~, WTC] = princomp(WF); 
    otherwise
        uiwait(msgbox([Method ' is not implemented']));
        return
end
axes(handles.axes4)
hold off; cla;
idCluster = DelimitClusters(WTC); % Delimit clusters

% Save trains and plot mean spikes
axes(handles.axes3)
hold off; cla;
clr = 'bgrcmyk';
ttl = [];
for k = 1:length(idCluster),
    if isempty(Trains)
        nTrs = 0;
    else
        nTrs = length(Trains.Spikes);
    end
    Trains.Spikes{nTrs+1} =  Tsp(idCluster{k})'/Args.Fs;
    if nTrs == 0
        id ='01';
    else
        id = setdiff(1:99,str2num(Trains.Titles));
        id = num2str(id(1),'%2.2d');
    end
    Trains.Titles(nTrs+1,:) = id;
    mWF = mean(WF(idCluster{k},:));
    stdWF = std(WF(idCluster{k},:));
    plot(mWF, clr(k),'LineWidth',2)
    hold on
    plot(mWF-stdWF, [clr(k) ':'],'LineWidth',2)
    plot(mWF+stdWF, [clr(k) ':'],'LineWidth',2)
    ttl = [ttl ' Tr' id ' = ' num2str(length(idCluster{k})) ' sps;'];
end
xlim([1 size(WF,2)])
title(ttl)

PlotSpikeTrains_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function EliminateSpikeTrains_Callback(hObject, eventdata, handles)
global Args Trains
if isempty(Trains), beep; return; end
answ = inputdlg({'Eliminate spike trains (e.g. [1:5, 30:32]): '},'Input', 1);
if isempty(answ), return; end
Trs = str2num(Trains.Titles);
[~,id] = setdiff(Trs,str2num(answ{1}));
Trains.Spikes = Trains.Spikes(id);
Trains.Titles = Trains.Titles(id,:);
PlotSpikeTrains_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function ExportSpikeTrains_Callback(hObject, eventdata, handles)
global Args Trains
if isempty(Trains)
    beep
    return
end
Trs = str2num(Trains.Titles);
answ = inputdlg({'Export spike trains (e.g. [1:5, 30:32]): '},'Input', 1);
if isempty(answ), return; end
[~,id] = intersect(Trs,str2num(answ{1}));
if isempty(id),
    uiwait(errordlg('No such trains awailable.'))
    return; 
end
[fname, pname] = uiputfile('*.mat', 'File to save spike trains.');
if isequal(fname,0) || isequal(pname,0)
    return
end

ExportTrains.Spikes = Trains.Spikes(id);
ExportTrains.Titles = Trains.Titles(id,:);
save(fullfile(pname, fname),'ExportTrains');
uiwait(msgbox(['Spike trains: [' num2str(Trs(id)') '] have been saved.']))


% --------------------------------------------------------------------
function ImportSpikeTrains_Callback(hObject, eventdata, handles)
global Trains
[fname, pname] = uigetfile({'*.mat;*.txt','Spike Trains: (*.mat, *.txt)'}, 'Select file with spike trains.');
if isequal(fname,0) || isequal(pname,0)
    return
end
[~,~,EXT] = fileparts(fname);

switch lower(EXT)
    case '.mat'
        load(fullfile(pname, fname));
    case '.txt'
        s = load(fullfile(pname, fname));
        ncl = size(s,2);
        if ncl == 1
            ExportTrains.Spikes{1} = s;
            ExportTrains.Titles = '01';
        elseif ncl == 2
            ExportTrains.Spikes{1} = s(s(:,2) == 1,1);
            ExportTrains.Titles = '01';
        else
            uiwait(errordlg('The file format must be either: a) a column of spike times or b) two columns [time binary(spike)].'))
            return;
        end            
    otherwise
            uiwait(errordlg('Unsupported file format.'))
            return
end        
if ~exist('ExportTrains','var')
    uiwait(errordlg(['The file ' fname ' has no spike trains.']))
    return;
end
if isempty(Trains)
    Trains = ExportTrains;
else
    Trains.Spikes = {Trains.Spikes{:}  ExportTrains.Spikes{:}};
    TrsEx = str2num(Trains.Titles);
    TrsNw = str2num(ExportTrains.Titles);
    [~,ia] = intersect(TrsNw,TrsEx);
    mTr = max(10,max(str2num(Trains.Titles)));
    for k = 1:length(ia)
        ExportTrains.Titles(ia(k),:) = num2str(mTr + k);
    end
    Trains.Titles = [Trains.Titles; ExportTrains.Titles];
end
PlotSpikeTrains_Callback(hObject, eventdata, handles)
newtrains = str2num(ExportTrains.Titles);
uiwait(msgbox(['New trains [' num2str(newtrains') '] have been imported.']))
set(handles.StatusTrains,'String',['Sp. Trains = ' num2str(length(Trains.Spikes))])


% --------------------------------------------------------------------
function wICAartefactFiltering_Callback(hObject, eventdata, handles)
global Args LFP Axis1Flag
if isempty(LFP), beep; return; end
if ~strcmpi(Axis1Flag,'LFPs'),
    uiwait(msgbox('This function works with LFPs only.'))
    return
end

xlm = get(handles.axes1,'Xlim');
tt = round(Args.Fs*(xlm - Args.T0));
if tt(1) < 1, tt(1) = 1; xlm(1) = Args.T0; end
tt(2) = min(tt(2),size(LFP,2));

        
[A, s] = MAKE_ICA(LFP(:,tt(1):tt(2)), 'NDIM', 'auto',...
    'verbose', 'off', 'ica_type', 'fastica', 'ndim_threshold', 0.99);


% [s, A, W] = fastica(LFP(:,tt(1):tt(2)), 'finetune', 'pow3', 'verbose',  'off','numOfIC',5);

axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','on')
PlotLoadings(A)
% axes(handles.axes4); cla; hold off;
% set(handles.axes4,'Visible','off')
axes(handles.axes1); cla; hold off;
set(handles.axes1,'Visible','on')
PlotEEG(s,Args.Fs,'a',[],'Preliminary artifact selection',xlm(1),'bgrcmyk')

answ = inputdlg({'Sources containing artifacts:'},...
    'Select artificial sources',1,{''});
if isempty(answ), beep; return; end

id = intersect(1:size(s,1),str2num(answ{1}));
if isempty(id), beep; return; end
s = s(id,:);
A = A(:,id);

nx = size(s,2);
L = min(13,ceil(log2(nx)));
nX = ceil(nx/2^L)*2^L;
% number of points to extend to 2^L length if needed
if nx/2 ~= ceil(nx/2),
    dN = nX - nx - 1;
else
    dN = nX - nx;
end
% [sden,cfs] = cmddenoise(s(1,:),'sym4',5,'h',3,thrParams);

% [sden,CXC,LXC,PERF0,PERFL2] = wdencmp('gbl',s(1,:),'db3',12, 500, 'h', 1);

for k = 1:size(s,1),
    s2 = wextend('1D', 'per', s(k,:), dN, 'r');
    [swa,swd] = swt(s2, L, 'db1');
    
    % hard thresholding
    ss = sort(abs(swd(:)));
    thld = ss(round(length(ss)*0.95));
    swd_Den = (abs(swd) > thld).*swd;
    
    % inverse transform
    xd = iswt(swa, swd_Den, 'db1');
    s(k,:) = xd(1:nx);
end
PlotEEG(s,Args.Fs,'a',[],'artifacts found by wICA',xlm(1),'bgrcmyk')

Butt = questdlg('Remove found artifacts?','Your choice','Yes','No','No');
if strcmpi(Butt, 'Yes')
    LFP(:,tt(1):tt(2)) = LFP(:,tt(1):tt(2)) - A*s;
    PlotLFPs_Callback(hObject, eventdata, handles)
else
    beep;
end


% --------------------------------------------------------------------
function PlaySignal_Callback(hObject, eventdata, handles)
global Args LFP G LFP_CA1 Axis1Flag
persistent snumb
if isempty(Axis1Flag),
    beep;
    return;
end
[X, chan, ArgsG] = SelectSignal(hObject, eventdata, handles);
if isempty(X), beep; return; end

set(handles.ChannelGroup,'Visible','on')
set(handles.GeneratorGroup,'Visible','off')
set(handles.LoadingsGroup,'Visible','off')
pause(0.2)
X = 0.99*X/max(abs(X));
sound(X, ArgsG.Fs)


% --------------------------------------------------------------------
function MathOperationOverLFPs_Callback(hObject, eventdata, handles)
global LFP_CA1
persistent math_operation
if isempty(LFP_CA1), beep; return; end
if isempty(math_operation),
    math_operation = 'x(k,:) = x(k,:) + 0.5*k';
end

answ = inputdlg({'Math operation (x(k,:) is the virtual LFP at the k-th channel): '},'Input', 1, {math_operation});
math_operation = answ{1};
x = LFP_CA1;
for k = 1:size(x,1)
    try 
        eval([math_operation ';'])
    catch err
       errordlg(err.message)
       return;
    end
end
LFP_CA1 = x;
PlotCA1LFPs_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
function FilterTetrode_Callback(hObject, eventdata, handles)
global Args LFP Axis1Flag LFPttr Tetrode
persistent answ
if isempty(LFP)
    beep;
    return;
end
if isempty(answ)
    answ = {'[1, 5, 6, 9]','500','5000','Sphere','5'};
end


answ = inputdlg({'Tetrode electrodes:','Cutoff HPF (Hz):',...
    'Cutoff LPF (Hz):','Thresholding Method (Square, Sphere)',...
    'Threshold Factor (for detection of spikes):'},...
    'Tetrode',1,answ);
if isempty(answ), return; end
Electrodes = str2num(answ{1});
Electrodes = intersect(Electrodes,1:size(LFP,1));
if length(Electrodes) ~= 4,
    uiwait(errordlg('Wrong electrodes'));
end

FilterBanc = [];
FilterBanc.HPF = str2num(answ{2});
FilterBanc.LPF = str2num(answ{3});
FACTOR = str2num(answ{5});

h = waitbar(0,'Working...');

LFPttr = zeros(4,size(LFP,2));
ChanFactor = zeros(4,1);
for k = 1:4,
    LFPttr(k,:) = FilterLFPs(LFP(Electrodes(k),:), Args.Fs, FilterBanc);
    ChanFactor(k) = std(LFPttr(k,:));
    LFPttr(k,:) = LFPttr(k,:)/ChanFactor(k);
end
Spikes = [];
switch lower(answ{4})
    case 'square'
        for k = 1:4,
            THR = median(LFPttr(k,:)) - FACTOR*median(abs(LFPttr(k,:))/0.6745);
            Spikes = [Spikes, find(LFPttr(k,1:end-1) > THR & LFPttr(k,2:end) <= THR)];
        end
        Spikes = unique(sort(Spikes));
    case 'sphere'
        sph = inv(sqrtm(cov(LFPttr'))); % sphering
        Z = sph*LFPttr;
        Z(Z > 0) = 0;
        R = sqrt(sum(Z.^2)) - FACTOR;
        R(R < 0) = 0;
        Spikes = findmaxima(R);
    otherwise
        uiwait(msgbox('unknown thresholding method'));
        return;
end

N = round(0.3e-3*Args.Fs);
for k = 1:length(Spikes)
    M = LFPttr(:,Spikes(k) + (-(N-1):N));
    [~,~,nT] = min2(M);
    Spikes(k) = Spikes(k) + nT - N;
end
Spikes = unique(Spikes);

nSps = length(Spikes);
WF = zeros(4,96,nSps);
SF = zeros(2,96,nSps);
AF = zeros(4,2,nSps);
tw = (-27:28); 
tw2 = tw(1):0.5:tw(end);
N = 5;
pr_done = 0.05*nSps; tic;
for k = 1:nSps,
    wf = LFPttr(:,Spikes(k) + tw);
    wf2 = spline(tw, wf, tw2);      % upsample
    [~,~,nT] = min2(wf2(:, -2*tw(1) + (-(N-1):N)));
    mn = -2*tw(1) - N + nT; 
    Spikes(k) = Spikes(k) + tw2(mn);
    WF(:,:,k) = wf2(:,mn + (-46:49));
    WF(:,:,k) = WF(:,:,k) - repmat(mean(WF(:,:,k),2),1,size(WF,2));
    [A, s] = MAKE_ICA(WF(:,:,k), 'NDIM', 'auto', 'verbose', 'off', 'ica_type', 'kdica');
    % indexes of "good" components
    s1 = s; s1(s1 > 0) = 0;
    C = sum(A.^2).*mean(s1.^2,2)';
    [~,ii] = sort(C,'descend');
    AF(:,:,k) = A(:,ii(1:2)); 
    SF(:,:,k) = s(ii(1:2),:);
    if k >= pr_done
        pr_done = pr_done + 0.05*nSps;
        tElapsed = toc;
        tLeft = (nSps-k)*tElapsed/k;
        tMins = floor(tLeft/60); tSecs = round(tLeft - tMins*60);
        waitbar(k/nSps, h, ['Working... Left: ' num2str(tMins)...
            'min ' num2str(tSecs) 's']);
    end
end
% for k = 1:2,
%     id = find(diff(Spikes(:)) < Args.Fs*0.5e-3); % spikes are too close
%     L0 = min([LFPttr(1,Spikes(id)); LFPttr(2,Spikes(id));...
%         LFPttr(3,Spikes(id)); LFPttr(4,Spikes(id))]);
%     L1 = min([LFPttr(1,Spikes(id+1)); LFPttr(2,Spikes(id+1));...
%         LFPttr(3,Spikes(id+1)); LFPttr(4,Spikes(id+1))]);
%     idrop = L0 < L1;
%     Spikes([id(idrop)+1; id(~idrop)]) = [];
% end
% 
% 
% N = round(0.3e-3*Args.Fs);
% idBad = [];
% for k = 1:length(Spikes)
%     M = LFPttr(:,Spikes(k) + (-(N-1):N));
%     [~,nC,nT] = min2(M);
%     if nT > 1 && nT < 2*N
%         ii = Spikes(k) + nT - N;
%         y = LFPttr(nC, ii + (-1:1));
%         xm = 0.5*(y(1)-y(3))/(y(1) - 2*y(2) + y(3));
%         Spikes(k) = ii + xm;
%     else
%         idBad = [idBad k];
%     end
% end
% Spikes(idBad) = [];
% 
close(h)
Spikes = (Spikes-1)/Args.Fs;
Tetrode.WaveForms = WF;
Tetrode.WFLoadings = AF;
Tetrode.WFActivations = SF;
Tetrode.Electrodes = Electrodes;
if isfield(Tetrode,'Spikes'),
    Tetrode.Spikes{2} = Tetrode.Spikes{1};
end
Tetrode.Spikes{1} = Spikes;
Tetrode.SortedTrains = [];
PlotTetrode_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function PlotTetrode_Callback(hObject, eventdata, handles)
global Args LFP LFP_CA1 Axis1Flag LFPttr Tetrode
if isempty(LFPttr), 
    beep;
    return;
end
axes(handles.axes1)
Tlim = get(handles.axes1,'Xlim');
if Tlim(1) < 0, 
    Tlim(1) = 0; 
    xlim(Tlim)
end
if Tlim(2)*Args.Fs + 1 > size(LFPttr,2), 
    Tlim(2) = (size(LFPttr,2) - 1)/Args.Fs; 
    xlim(Tlim)
end 
if strcmpi(Axis1Flag,'Tetrode')
    yscale = str2num(get(handles.Yscale,'String'));
else
    set(handles.Yscale,'String','auto');
    yscale = [];
end
iLim = round(Tlim*Args.Fs)+1;

if strcmpi(get(handles.PlotWorst,'Checked'),'on')
    step = ceil(diff(iLim)/1000);
elseif strcmpi(get(handles.PlotBest,'Checked'),'on')
    step = 1;
else
    step = ceil(diff(iLim)/2000);
end    
hold off

if isfield(Tetrode,'SortedTrains') && ~isempty(Tetrode.SortedTrains),
    Trains = Tetrode.SortedTrains;
    TTL = 'sorted trains';
else
    Trains = Tetrode.Spikes;
    TTL = ['tetrode recordings, channels: [' num2str(Tetrode.Electrodes) ...
    '] (' num2str(length(Trains{1})) ' spikes detected)'];
end    
    

PlotEEG(LFPttr(:,iLim(1):step:iLim(2)), Args.Fs/step, 'T', yscale, TTL, Tlim(1));
hold on
yt = get(gca,'YTick'); dy = yt(2) - yt(1);

AY = ceil(length(Trains)/3); 
set(gca,'YLim',dy*[-1, 4 + AY])
DS = dy*(AY + 1)/(1+length(Trains));
D0 = dy*(4 + AY);
clr = 'bgrcmyk'; CLR_LEN = length(clr);
for k = 1:length(Trains),
    Spikes = Trains{k};
    id = Spikes > Tlim(1) & Spikes < Tlim(2);
    yp = D0 - k*DS;
    plot(Spikes(id), yp + zeros(1,length(Spikes(id))),...
        [clr(mod(k - 1, CLR_LEN) + 1) '+'],'MarkerSize',10)
    plot(Tlim, yp + [0 0],clr(mod(k - 1, CLR_LEN) + 1))
end
    
set(handles.axes1,'Visible','on')
set(handles.LFPGroup,'Visible','on')
Axis1Flag = 'Tetrode';


% --------------------------------------------------------------------
function SaveDetectedSpikesForSorting_Callback(hObject, eventdata, handles)
global Args LFPttr Tetrode 
if isempty(LFPttr) || isempty(Tetrode) || ~isfield(Tetrode,'Spikes')
    beep;
    return;
end

DIRT = uigetdir('~/Desktop','Folder for saving sorting results');
if isempty(DIRT), return; end
Tetrode.TMPdir = DIRT;
for k = 1:4,
    scale = 2^15/(1.1*max(abs(LFPttr(k,:))));
    fid = fopen([DIRT filesep 'Tetrode' num2str(k) '.fil'], 'w');
    fwrite(fid, scale*LFPttr(k,:), 'short');
    fclose(fid);
end
Spikes = Args.Fs*Tetrode.Spikes{1}(:);
    save([DIRT filesep 'Tetrode.det'],'Spikes','-ascii');
uiwait(msgbox('Data have been saved. Do clustering now. Don''t close the progam!'))

% --------------------------------------------------------------------
function LoadClusteringResults_Callback(hObject, eventdata, handles)
global Args LFPttr Tetrode 
% Tetrode.TMPdir='/Users/valeri/Desktop/Tetrodes/'
if isempty(Tetrode) || ~isfield(Tetrode,'TMPdir')
    beep;
    return;
end

FCL = [Tetrode.TMPdir filesep 'Tetrode.cla'];
if ~exist(FCL,'file')
    uiwait(errordlg('No clustering results'))
    return
end

CL = load(FCL);
if length(CL) ~= length(Tetrode.Spikes{1}),
    uiwait(errordlg('Clustering results do not correspond to detected spikes'))
    return
end


uCL = unique(CL);
Tetrode.SortedTrains = [];
Tetrode.TrainIDX = [];
for k = 1:length(uCL),
    id = find(CL == uCL(k));
    Tetrode.TrainIDX{k} = id;
    Tetrode.SortedTrains{k} = Tetrode.Spikes{1}(id);
end

FCL = [Tetrode.TMPdir filesep 'Tetrode.ext'];
Tetrode.SpikeFtrs = load(FCL);

PlotTetrode_Callback(hObject, eventdata, handles)
PlotClusteringPartition_Callback(hObject, eventdata, handles)
uiwait(msgbox([num2str(length(uCL)) ' trains have been loaded.']))

% --------------------------------------------------------------------
function PlotSpikeWaveForms_Callback(hObject, eventdata, handles)
global Args LFPttr Tetrode 
persistent answ
if isempty(Tetrode) || ~isfield(Tetrode,'SortedTrains')
    beep;
    return;
end
if isempty(answ)
    answ = {'[1, 2]','0.1','[-0.5, 2]'};
end


answ = inputdlg({'Train to show:','Y scale','Time interval (ms):'},...
    'Spike WaveForms',1,answ);
if isempty(answ), return; end


axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')

axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','on')

nTr = str2num(answ{1});
scl = str2num(answ{2});
W = str2num(answ{3})*1e-3*Args.Fs;


Nmax = size(LFPttr,2);
clr = 'bgrcmyk'; CLR_LEN = length(clr);

dt = 1e3/Args.Fs;
TTL = [];
for k = 1:length(nTr)
    sp = 1 + round(Args.Fs*Tetrode.SortedTrains{nTr(k)});
    M = zeros(4,diff(W)+1,length(sp));
    for j = 1:length(sp),
        t = sp(j) + (W(1):W(2)); t(t<1) = 1; t(t > Nmax) = Nmax;
        M(:,:,j) = LFPttr(:,t);
    end
    WF = mean(M,3);
    sWF = std(M,0,3);
    
    cl = clr(mod(nTr(k) - 1, CLR_LEN) + 1);
    for j = 1:4,
        plot((W(1):W(2))*dt, scl*(4-j) +  WF(j,:),cl,'LineWidth',2)
        hold on
        plot((W(1):W(2))*dt, scl*(4-j) +  WF(j,:)+sWF(j,:),[cl '--'])
        plot((W(1):W(2))*dt, scl*(4-j) +  WF(j,:)-sWF(j,:),[cl '--'])
    end
    ylim(scl*[-1 4]);
    TTL = [TTL ' Train' num2str(nTr(k)) ' = ' num2str(length(sp)) 'sp; '];
end
title(TTL,'FontSize',12)
    
   


% --------------------------------------------------------------------
function PlotSpikeFeatures_Callback(hObject, eventdata, handles)
global Args Tetrode 
persistent answ
if isempty(Tetrode) || ~isfield(Tetrode,'SortedTrains')
    beep;
    return;
end
IDX = Tetrode.TrainIDX;
Ftrs = Tetrode.SpikeFtrs;
if isempty(answ)
    answ = {'[1:3]','[1,2]'};
end
answ = inputdlg({'Trains to plot:',['Features (two, max ' num2str(size(Ftrs,2)) '):']},...
    'PlotParameters',1,answ);
if isempty(answ), return; end

nTr = str2num(answ{1});
if isempty(nTr) || max(nTr) > length(IDX),
    beep
    return;
end
idFtrs = intersect(1:size(Ftrs,2),str2num(answ{2}));
if length(idFtrs) ~= 2,
    beep
    return;
end

axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')

axes(handles.axes3); cla; hold off;
set(handles.axes3,'Visible','on')
clr = 'bgrcmyk'; CLR_LEN = length(clr);

for k = 1:length(nTr)
    id = IDX{nTr(k)};
    plot(Ftrs(id,idFtrs(1)),Ftrs(id,idFtrs(2)), [clr(mod(nTr(k) - 1, CLR_LEN) + 1) '.'])
    hold on
end
xlabel(['feature #' num2str(idFtrs(1))],'FontSize',12)
ylabel(['feature #' num2str(idFtrs(2))],'FontSize',12)

% --------------------------------------------------------------------
function PlotClusteringPartition_Callback(hObject, eventdata, handles)
global Args Tetrode 
if isempty(Tetrode) || ~isfield(Tetrode,'SortedTrains')
    beep;
    return;
end
IDX = Tetrode.TrainIDX;
Ftrs = Tetrode.SpikeFtrs;
% define centroids
nCl = length(IDX);
C = zeros(nCl,size(Ftrs,2)); % centroids
S = zeros(nCl,1); % intra-clustert distance
for k = 1:nCl,
    id = IDX{k};
    C(k,:) = mean(Ftrs(id,:));
    for j = 1:length(id),
        S(k) = S(k) + norm(Ftrs(id(j),:) -C(k,:)); 
    end
    S(k) = S(k)/length(id);
end
d = zeros(nCl); % intercluster normalized distance
for k = 1:nCl,
    for j = k + 1:nCl,
        d(j,k) = norm(C(k,:) - C(j,:))/(S(k) + S(j));
        d(k,j) = d(j,k);
    end
end
dz = squareform(d);
Z = linkage(dz,'average');
axes(handles.axes2); cla; hold off;
set(handles.axes2,'Visible','off')

axes(handles.axes4); cla; hold off;
set(handles.axes4,'Visible','on')

dendrogram(Z,'colorthreshold',0.5)
yl = get(gca,'Ylim');
set(gca,'YLim',[0 yl(2)]);
xlabel('train','FontSize',12)
title('normalized inter-cluster distance','FontSize',12)


% --------------------------------------------------------------------
function ExtractSpikeFeatures_Callback(hObject, eventdata, handles)
global Args Tetrode
if isempty(Tetrode) || ~isfield(Tetrode,'WFLoadings') || isempty(Tetrode.WFLoadings)
    beep;
    return;
end


WFA = Tetrode.WFLoadings;
WFS = Tetrode.WFActivations;
nSps = size(WFA,3);

Delta = zeros(nSps,1);

for k = 1:nSps,
%     A = WFA(:,:,k); 
    s = WFS(:,:,k);
    s(s>0) = 0;
%     C = sum(A.^2).*mean(s.^2,2)';
    C = mean(s.^2,2)';
    Delta(k) = C(2)/C(1);
%     subplot(2,1,2)
%     plot(WFA(:,:,k),'o-')
%     ylim([0 1])
%     subplot(2,1,1)
%     plot(WFS(:,:,k)')
%     title(num2str(Delta(k)),'FontSize',12)    
%     ylim([-10 5]); grid on
end
idSimple = Delta < 0.15;

WFSs = squeeze(WFS(1,:,idSimple));
WFAs = squeeze(WFA(:,1,idSimple));
figure('color','w','position',[100 100 500 600])
subplot(2,1,1)
hold off; cla;
Densitogram(WFSs',0.5e3*[-46,49]/Args.Fs,[-15 5])
set(gca,'FontSize',12);
xlabel('time (ms)','FontSize',12)
title(['IC activation (' num2str(size(WFSs,2)) ' spikes)'],'FontSize',14)

subplot(2,1,2)
Densitogram(WFAs',[],[0 1])
set(gca,'XTick',1:4);
set(gca,'FontSize',12);
xlabel('electrode','FontSize',12)
title('IC loading','FontSize',14)

[COEFF, SCORE, LATENT] = princomp(WFSs');
%%
plot(WFAs(1,:),WFAs(3,:),'.','MarkerSize',6)
%plot(COEFF(:,2), COEFF(:,1),'.','MarkerSize',6)

save('TestTetrode','Tetrode')


% --------------------------------------------------------------------
function EliminateStrongLowFrequencyArtifact_Callback(hObject, eventdata, handles)
global Args LFP G LFP_CA1 Axis1Flag  GnrsSet wICA
persistent A s nG xlm swa swd LEV 

if isempty(LFP) || (~strcmpi(Axis1Flag,'LFPs') && ~strcmpi(Axis1Flag,'wICA')) 
    beep
    msgbox('First select LFP window');
    return;
end
%exit
MaxWind = str2num(get(handles.wICAmaxwind,'String'));

L = round(get(handles.wICAwtLev,'Value'));

h = msgbox('Working..., don''t press any key, JUST WAIT!');
if strcmpi(get(handles.wICApanel,'Visible'),'off') || isempty(s)
    xlm = get(handles.axes1,'Xlim');
    LEV = L;
    tt = round(Args.Fs*(xlm - Args.T0));
    if tt(1) < 1, tt(1) = 1; xlm(1) = Args.T0; end
    tt(2) = min(tt(2),size(LFP,2));
    wICA.tt = tt;
    [A, s] = MAKE_ICA(LFP(:,tt(1):tt(2)), 'NDIM', 'auto',...
        'verbose', 'off', 'ica_type', 'kdica', 'ndim_threshold', 0.99);
    nG = 1;
    set(handles.wICApanel,'Visible','on')
    set(handles.LFPGroup,'Visible','off')
    set(handles.LoadingsGroup,'Visible','off')
    set(handles.GeneratorGroup,'Visible','off')
    set(handles.wICAnG,'String',num2str((1:size(s,1))'))
    set(handles.wICAnG,'Value',nG)
    set(handles.axes3,'Visible','off')
    set(handles.axes4,'Visible','off')
    Axis1Flag = 'wICA';
    Lev = min(LEV,floor(log2(size(s,2))));
    [swa, swd] = SWTransform(s(nG,:), Lev);
end
chan = get(handles.wICAnG,'Value');
if isempty(nG) || chan ~= nG || isempty(LEV) || LEV ~= L,
    nG = chan; LEV = L;
    Lev = min(LEV,floor(log2(size(s,2))));
    [swa, swd] = SWTransform(s(nG,:), Lev);
end

ThrMult = str2num(get(handles.wICAthreshold,'String'));
Th = (exp(ThrMult)-1)*median(abs(swd(1,:)))/0.67;

swd_Den = (abs(swd) > Th).*swd;
Artf = iswt(swa, swd_Den, 'db1'); % inverse transform
Artf = Artf(1:size(s,2)); % truncation (if needed)
Sign = s(nG,:) - Artf;

axes(handles.axes1); cla;
PlotEEG(s,Args.Fs,'g',[],...
    ['Select the generator with artifacts and ajust the treshold and WT level (max ' ...
    num2str(MaxWind) 's window)'], xlm(1));
Lx = get(gca,'Xlim');
Lx(2) = min(Lx(2),Lx(1) + MaxWind);
xlim(Lx);

axes(handles.axes2); cla;
PlotEEG([Artf; Sign], Args.Fs,{'art','sgn'},[],...
    'Red: artifactual (to be elimnated from LFPs) and Blue: background (to be kept in LFPs) activities', xlm(1),'rb')
xlim(Lx);

wICA.A = A(:,nG);
wICA.s = Artf;
close(h)



function wICAthreshold_Callback(hObject, eventdata, handles)
EliminateStrongLowFrequencyArtifact_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function wICAthreshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in wICAnG.
function wICAnG_Callback(hObject, eventdata, handles)
EliminateStrongLowFrequencyArtifact_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function wICAnG_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function wICAwtLev_Callback(hObject, eventdata, handles)
L = round(get(handles.wICAwtLev,'Value'));
set(handles.wICAwtLev,'Value',L);
set(handles.wICATEXTwtlevel,'String',['WT Lev = ' num2str(L)])
EliminateStrongLowFrequencyArtifact_Callback(hObject, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function wICAwtLev_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes on button press in wICAapply.
function wICAapply_Callback(hObject, eventdata, handles)
global LFP wICA
set(handles.wICApanel,'Visible','off');
tt = wICA.tt;
LFP(:,tt(1):tt(2)) = LFP(:,tt(1):tt(2)) - wICA.A*wICA.s;
PlotLFPs_Callback(hObject, eventdata, handles)



function wICAmaxwind_Callback(hObject, eventdata, handles)
L = str2num(get(handles.wICAmaxwind,'String'));
if L <= 0, set(handles.wICAmaxwind,'Value',20); end
EliminateStrongLowFrequencyArtifact_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function wICAmaxwind_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function Help_Unmasking_Callback(hObject, eventdata, handles)
M = computer; M = M(1:3);
switch M
    case 'MAC'
        if exist('HelpStrongBackground.pdf','file')
            open('HelpStrongBackground.pdf')
        else
            errordlg('Can''t find the file with help')
        end
    case 'GLN'
        if exist('/opt/ICA/HelpStrongBackground.pdf','file')
            unix('epdfview /opt/ICA/HelpStrongBackground.pdf')
        else
            errordlg('Can''t find the file with help')
        end
    otherwise
            errordlg('Unknown platform.')        
end
