function CalculateAndPlotWTspectrum(X, Args, Band)

Fs = Args.Fs;
nPts = length(X);
step = min(round(Fs/20),ceil(nPts/3000));
X = X(1:step:nPts);

Args.fo = 1;                  % morlet parameter
Args.Dj = 0.0833/4;
Args.aSt = 1/Band(2);           % minimal scale (s)
Args.aEn = 1/Band(1);                 % max scale (s)
Args.rate = Fs/step;               % time rate (120Hz)
Args.b = Args.T0 + (1:step:nPts)/Fs;                   % time grid
Args = SetDefaultWTParameters(Args);   % Set others to default
Args = ConeOfInfluence(Args);          % define the cone of influence     

[WT, F] = wt([Args.b; X], 'S0', Args.a(1), 'MaxScale', Args.a(end), 'MakeFigure', 0);
E = (F'*ones(1,size(WT,2))).*(abs(WT).^2);
hold off
PlotWT(E, [], Args, 0, 1, 0)
hold on
xm = max(abs(X));
tks = get(gca,'YTick');
YLM = tks(round(0.3*length(tks)));
plot(Args.b, YLM-X/xm, 'w-', 'LineWidth',1)


