function Args = ConeOfInfluence(Args)

if nargin ~= 1 || ~isstruct(Args), error('Argument'); end
%% Find Cone Of Influence
if ~isempty(Args.b)
    ko = Args.fo;
    n1 = length(Args.b);
    dt = 1/Args.rate;
    coi = dt*[1E-5,1:((n1+1)/2-1),fliplr((1:(n1/2-1))),1E-5]/(sqrt(2)*ko);  % COI [Sec.3g]
else
    coi = [];
end
Args.COI = coi;
