function Y = ConvolveTrainWithGaussianKernel(Train, Tlim, w, Fs)
%
% This function convolve train with gaussian kernel
%
%



Train(Train < Tlim(1)) = [];
Train(Train > Tlim(2)) = [];
Train = round(Fs*(Train - Tlim(1)));
w = round(1e-3*Fs*w/2);


xx = -4*w:4*w;
K = normpdf(xx, 0, w);
id2 = ceil(length(xx)/2);

n = round(Fs*diff(Tlim));
Y = zeros(1, n);

for k = 1:length(Train)
    t = Train(k);
    dum = t + xx;
    if t < id2
        id = dum >= 1;
        Y(dum(id)) = Y(dum(id)) + K(id);
    elseif t > n - id2
        id = dum <= n;
        Y(dum(id)) = Y(dum(id)) + K(id);
    else
        Y(t + xx) = Y(t + xx) + K;
    end
end
