function [LFP, Args] = EliminatePPartifacts2(LFP, Args)


mLFP = mean(LFP,2);
y = LFP - mLFP*ones(1,size(LFP,2));
% fcut = 1300;
% [b,a] = ellip(2, 0.1, 40, 2*fcut/Args.Fs, 'high');
% x = filtfilt(b, a, mean(y));
ym = mean(y);
z = (ym(3:end)-ym(1:end-2))/2;
if isfield(Args,'EpochLength'),
    nEps = length(ym)/Args.EpochLength;
    idEnd = Args.EpochLength*(1:nEps-1);
z(idEnd) = 0;
z(idEnd-1) = 0;
end
z = [0 z 0];
t = (0:length(z)-1)/Args.Fs;
xlm = t([1,end]); 
ylm = max(abs(z))*[-1 1];
plot(t,z,'k')
xlim(xlm)
ylim(0.25*ylm)
title('Artificial spikes detected in LFPs')
uiwait(msgbox('Select the threshold for artifacts in the bottom plot.'));

[x1,y1,but] = ginput(1);
DTmin = round(0.01*Args.Fs); % minimal distance between artifacts
if but ~= 1, return; end
if y1 < 0,
    idx = find(z(1:end-1) > y1 & z(2:end) <= y1) + 1;
else
    idx = find(z(1:end-1) < y1 & z(2:end) >= y1) + 1;
end
idMin = find(diff(idx) < DTmin) + 1;
hold on
plot(t(idx),y1*ones(1,length(idx)),'b.');
if ~isempty(idMin)
    plot(t(idx(idMin)),y1*ones(1,length(idx(idMin))),'r.');
    ButtonName = questdlg('Detected artifacts within 10ms interval (red dots)','warning','Drop','Keep','Drop');
    if strcmpi(ButtonName,'Drop')
        plot(t(idx(idMin)),y1*ones(1,length(idx(idMin))),'w.');
        idx(idMin) = [];
    end
end

Args.ArtfctIDX = idx;

nPts2 = round(Args.Fs*0.0013);
nPts1 = -round(Args.Fs*0.0003);
nPts22 = round(Args.Fs*0.0016);
nPts11 = -round(Args.Fs*0.0006);
fcut = 1000;
w0 = min(2*fcut/Args.Fs, 0.9);
if  nPts22-nPts11 > 5,
    [b,a] = ellip(2, 0.1, 40, w0, 'low');
else
    [b,a] = ellip(1, 0.1, 40, w0, 'low');
end
for k = 1:size(LFP,1)
    for j = 1:length(idx)
       p = polyfit([nPts1 nPts2], LFP(k,idx(j)+[nPts1 nPts2]),1);
       LFP(k,idx(j)+[nPts1:nPts2]) = polyval(p,nPts1:nPts2);  
       LFP(k,idx(j)+[nPts11:nPts22]) = filtfilt(b, a, LFP(k,idx(j)+[nPts11:nPts22]));
    end
end
