function [WF, Tsp] = ExtractSpikeWaveForms(s, Tsp, W)
%
% s  - CSD from LFPs
% W  - W(1:2) - window arround spike (e.g., [-10 40]) in points, W(3) time
%      shift
%

nSps = length(Tsp);  % number of spikes
WF = zeros(nSps,2*(W(2)-W(1))+1);

% cut LFPs into WFs for CSD
for k = 1:nSps,
    WF(k,:) = spline(W(1):W(2), s(Tsp(k) + (W(1):W(2))), W(1):0.5:W(2));
end

WF = WF - mean(WF(:,1:(-W(1)-1)), 2)*ones(1,size(WF,2));

% Alaine WFs by their minimums

nW = round(2*W(3));  % maximal time shift for allignment
nn = -2*W(1);
[~,id] = min(WF(:,nn:(nn+nW)),[],2);
for k = 1:nSps,
    WF(k,:) = [WF(k,id(k):end) zeros(1,id(k)-1)];
end
WF(:,(end-nW):end) = [];

% Check for Duplets and delete them
 
id = find(min(WF(:,1:(-2*W(1) - 1)),[],2) < WF(:,-2*W(1)));
WF(id,:) = [];
Tsp(id) = [];

