function X = FilterLFPs(X, Fs, FilterBanc)

h = waitbar(0,'Working...');


nCh = size(X,1);
if isfield(FilterBanc,'Notch') && ~isempty(FilterBanc.Notch)
    Fnotch = FilterBanc.Notch;
    for j = 1:length(Fnotch)
        wo = Fnotch(j)/(Fs/2);  bw = wo/100;
        [b,a] = iirnotch(wo, bw, -2);
        for k = 1:nCh,
            X(k,:) = filtfilt(b, a, X(k,:));
            waitbar(k/(3*nCh),h)
        end
    end
end
if isfield(FilterBanc,'LPF') && ~isempty(FilterBanc.LPF) && FilterBanc.LPF < Fs/2.2
    wo = FilterBanc.LPF/(Fs/2);
    [b,a] = butter(6,wo,'low');
    for k = 1:nCh,
        X(k,:) = filtfilt(b, a, X(k,:));
        waitbar(1/3 + k/(3*nCh),h)
    end
end

if isfield(FilterBanc,'HPF') && ~isempty(FilterBanc.HPF)
    if FilterBanc.HPF >= 0.01*Fs
        wo = FilterBanc.HPF/(Fs/2);
        [b,a] = butter(6,wo,'high');
    else
        alpha = Fs/(Fs + FilterBanc.HPF);
        b = alpha*[1 -1];
        a = [1 -alpha];
    end
    for k = 1:nCh,
        X(k,:) = filtfilt(b, a, X(k,:));
        X(k,:) = detrend(X(k,:),'constant');
        waitbar(2/3 + k/(3*nCh),h)
    end

end
close(h)
end