function [Args, LFP, Trains] = LoadSMRfile(FileName)


Args = []; LFP = []; Trains = [];

Args.FDIR = fileparts(FileName); 
Args.FILE = FileName;
% read LFPs
answ = inputdlg({'Downsample the data (1 - no, 2 - two times):'},'Importing data', 1,{'1'});
if isempty(answ), DWN = 1; end
DWN = round(str2num(answ{1}));
[tmp, Args.Fs, dum1, dum2, dum3, tWinds] = READ_SMR(FileName, 1, 'all', [], 'off', DWN);
nch = length(tmp);
if nch == 0, 
    warndlg('No LFP channels','warning','modal'); 
    LFP = zeros(1,100); % make fake LFP channel
    Args.Fs = 100;
else
    if min(size(tmp{1})) > 1,
%         errordlg('File with multiple epochs, use FirstStep package','warning','modal');
        LFP = zeros(nch,length(tmp{1}(:)));
        for k = 1:nch,
            tmp2 = tmp{k}';
            LFP(k,:) = tmp2(:);
        end
        Args.EpochLength = size(tmp{1},2);
    else
        nPts = length(tmp{1});
        LFP = zeros(nch, nPts);
        for k = 1:nch, 
            nn = min(length(tmp{k}), nPts);
            LFP(k,1:nn) = tmp{k}(1:nn); 
        end
    end
    clear tmp;
end
% read spike trains
warning off
[Spikes, dum, SpikeChannels] = READ_SMR(FileName, 2, 'all', [], 'off');
if ~isempty(Spikes)
    if ~isempty(tWinds)
        tShift = [0; cumsum(tWinds(:,2) - tWinds(:,1))];
        for n = 1:length(Spikes),
            Saux1 = Spikes{n};
            Saux2 = [];
            for k = 1:size(tWinds,1)
                Saux2 = [Saux2; Saux1(Saux1 >= tWinds(k,1) & Saux1 <= tWinds(k,2)) - tWinds(k,1) + tShift(k)];
            end
            Spikes{n} = Saux2;
        end
    end
    Trains.Spikes = Spikes;
    Trains.Titles = num2str(SpikeChannels(:));
end
warning on
Args.T0 = 0;
