function [A, s] = MakeKDICA(u, NDIM)

L = size(u,2);

% Remove mean
Udc = mean(u,2);
Uac = u - repmat(Udc,1,L);

% Dimension reduction

[P, x] = princomp(Uac');
x = x(:,1:NDIM);


% Sphering
B = 2*inv(sqrtm(cov(x)));

% KDICA
W2 = KDICA(B*x'); % initial is JADE()

% unmixing matrix
W = W2*B*P(:,1:NDIM)';

% Mixing Matrix and activations
A = pinv(W);
s = W*u;











