function [X, factors] = NormalizeCurves(X)
%
%  [X , factors]= NormilizeCurves(X)
%
% This function normilizes loadings curves
% such that sum(u^2) = 1 for all curves
%
% X - matrix with curves (nElectrode x nCurves)
% factors - vector of factors (F) for sources (S)
%          EEG = X*S = (X/F)*(F*S)
% 
% V. Makarov, vmakarov@mat.ucm.es
% April 2008: first release
% Sept. 2008: added second output parameter
%

factors = sqrt(diag(X'*X));
X = X./(ones(size(X,1),1)*factors');
