function PlotLFPTraces(LFP, Args, T0, DT, GraphTitle, ChTitle, Mark, yscale, PlotPresision)
%
% PlotLFPTraces(LFP, Fs, T0, DT, GraphTitle)
% Plot in current axes LFP traces
%
%
% Valeri Makarov, vmakarov@mat.ucm.es
%
% Jan. 2009
%

if nargin < 4, 
    help PlotLFPTraces
    return;
end
if nargin < 5 || isempty(GraphTitle)
    GraphTitle = 'LFPs';
end
if nargin < 6 || isempty(ChTitle),
    ChTitle = 'e';
end
if nargin < 7 || isempty(Mark),
    Mark = 'k';
end
if nargin < 8,
    yscale = [];
end
if nargin < 9 || isempty(PlotPresision)
    PlotPresision = 1;
end

[nCh, nPt] = size(LFP);
Fs = Args.Fs;
T00 = T0 - Args.T0;
t1 = min(nPt-10,max(1,round(T00*Fs)));
T00 = (t1-1)/Fs;
dt = 1+round(DT*Fs);
dt = min(dt, nPt - t1);
if PlotPresision == 1,
    step = ceil(dt/1000);
elseif PlotPresision == 2,
    step = ceil(dt/2000);
else
    step = 1;
end
hold off
PlotEEG(LFP(:,t1:step:t1+dt), Fs/step, ChTitle, yscale,...
    GraphTitle, Args.T0+T00, Mark)
xlim(T0 + [0 DT])
