function PlotLFPs_TwoGenerators(LFP, GnrsSet, Fs, tLims)
persistent answer fig

nGSETs = length(GnrsSet);
nEls = size(LFP,1);

prompt = {'LFP channels to plot:',['First generator set (there are ' num2str(nGSETs) '):'],...
    'Generators to plot:', 'Second generator set:', 'Generators to plot:'};
n2 = num2str(max(2,nGSETs));

if isempty(answer)
    definput = {['1:' num2str(nEls)], '1', 'all', n2, 'all'};
else
    definput = answer;
end
answer = inputdlg(prompt, 'Input', [1 40], definput);

if isempty(answer), return; end

dum = answer{1}; 
if strcmpi(dum, 'all') 
    iEls = 1:nEls;
else
    iEls = eval(['[' answer{1} ']']);
    iEls = intersect(1:nEls,iEls);
    if isempty(iEls), iEls = 1:nEls; end
end

tt = round(tLims*Fs); dt = ceil(diff(tt)/5000);
mark = repmat('bgrcmyk',1,10);

if isempty(fig)
    fig = figure('color','w','Name','LFP and Generators','NumberTitle','off');
else
    figure(fig)
end
subplot(3,1,1)
ttl = num2str(iEls(:));
ttl = mat2cell(ttl, ones(size(ttl,1),1), size(ttl,2));
PlotEEG(LFP(iEls,tt(1):dt:tt(2)), Fs/dt, ttl, [], 'LFPs', (tt(1)-1)/Fs)
xlim(tLims)

for k = 1:2
    subplot(3,1,k+1)
    
    nS = str2num(answer{2*k});
    nS = intersect(nS, 1:nGSETs);
    if isempty(nS), nS = 1; end

    s = GnrsSet{nS}.s;
    T0 = GnrsSet{nS}.T0;
    
    maxG = size(s,1);

    nG = answer{2*k+1};
    if strcmpi(nG, 'all')
        nG = 1:maxG;
    else
        nG = eval(['[' nG ']']);
        nG = intersect(1:maxG,nG);
        if isempty(nG), nG = 1:maxG; end
    end
    
    ttl = [repmat('g',length(nG),1) num2str(nG(:))];
    ttl = mat2cell(ttl, ones(size(ttl,1),1), size(ttl,2));
    mark1 = mark(nG);
    
    TE = size(s,2)/Fs - T0;
    if TE < tLims(2)
        t2 = size(s,2);
    else
        t2 = size(s,2) - round((TE - tLims(2))*Fs);
    end
    if T0 > tLims(1)
        t1 = 1;
    else
        t1 = round((tLims(1) - T0)*Fs)+1;
        T0 = tLims(1);
    end

    if t2 > t1
        PlotEEG(s(nG,t1:dt:t2), Fs/dt, ttl, [], ['generator activations for set ' num2str(nS)], T0, mark1)
    end
    xlim(tLims)
end





end