function [X, chan, ArgsG] = SelectSignal(hObject, eventdata, handles, chan)
global Args LFP G Axis1Flag LFP_CA1

if nargin < 4 || isempty(chan),
    chan = get(handles.ChannelSelector,'Value');
end
xlm = round(Args.Fs*get(handles.axes1,'Xlim'));
X = [];
ArgsG = [];
switch Axis1Flag
    case 'LFPs'
        if isempty(LFP), return; end
        set(handles.ChannelSelector,'String',num2str((1:size(LFP,1))'))
        chan = intersect(chan,1:size(LFP,1));
        if isempty(chan), 
            chan = 1; 
            set(handles.ChannelSelector,'Value',1)
        end
        xlm(1) = max(xlm(1),1); xlm(2) = min(xlm(2),size(LFP,2));
        X = LFP(chan,xlm(1):xlm(2));
        ArgsG.Fs = Args.Fs; ArgsG.T0 = xlm(1)/Args.Fs; ArgsG.Type = 'LFP';
        if isfield(Args,'VoltDIM'),
            ArgsG.VoltDIM = Args.VoltDIM;
        else
            ArgsG.VoltDIM = 'mV';
        end            
    case 'CA1_LFPs'
        if isempty(LFP_CA1), return; end
        set(handles.ChannelSelector,'String',num2str((1:size(LFP_CA1,1))'))
        chan = intersect(chan,1:size(LFP_CA1,1));
        if isempty(chan), 
            chan = 1; 
            set(handles.ChannelSelector,'Value',1)
        end
        xlm(1) = max(xlm(1),1); xlm(2) = min(xlm(2),size(LFP_CA1,2));
        X = LFP_CA1(chan,xlm(1):xlm(2)); 
        ArgsG.Fs = Args.Fs; ArgsG.T0 = xlm(1)/Args.Fs; ArgsG.Type = 'CA1_LFP';
        if isfield(Args,'VoltDIM'),
            ArgsG.VoltDIM = Args.VoltDIM;
        else
            ArgsG.VoltDIM = 'mV';
        end            
    case 'G'
        if isempty(G), return; end
        set(handles.ChannelSelector,'String',num2str((1:size(G.s,1))'))
        chan = intersect(chan,1:size(G.s,1));
        if isempty(chan), 
            chan = 1; 
            set(handles.ChannelSelector,'Value',1)
        end
        ids = xlm - round(G.T0*Args.Fs);
        ids(1) = max(ids(1),1); ids(2) = min(ids(2),size(G.s,2));
        X = G.s(chan,ids(1):ids(2));
        ArgsG.Fs = Args.Fs; ArgsG.T0 = xlm(1)/Args.Fs; ArgsG.Type = 'G';
        ArgsG.VoltDIM = 'a.u.';
    otherwise
        uiwait(errordlg('This function works for LFPs and ICs only.','warning','modal'));
        return
end
