function [id, nTrig, T0] = SelectTrigger(Trains, Fs, iLims)
persistent answ
if isempty(answ),
    answ = {Trains.Titles(1,:),'[-5 25]'};
end
answ = inputdlg({['Trigger (available from: ' Trains.Titles(1,:) ' to '...
    Trains.Titles(end,:) ')'], 'Time interval (ms):'},'Input', 1, answ);
if isempty(answ), return; end
[dum,nTrig] =  intersect(str2num(Trains.Titles),str2num(answ{1}));
if isempty(dum), 
    uiwait(errordlg('No such trigger exists.','warning','modal')); 
end
Tlim = 1e-3*str2num(answ{2});
iL = round(Tlim*Fs);
nPts = diff(iL)+1;
iS = round(Trains.Spikes{nTrig}*Fs);
iS(iS < iLims(1)) = []; iS(iS > iLims(2)) = [];
id = ones(length(iS),1)*(iL(1):iL(2)) + iS * ones(1, nPts);
id(id < iLims(1)) = iLims(1); id(id > iLims(2)) = iLims(2);  
T0 = Tlim(1);