function Tsp = SubtractTrainsFormDetectedSpikes(Tsp, Trains, SubtrTrains, Fs)

if isempty(Trains) || isempty(SubtrTrains)
    return;
end
sbtrTrs = str2num(SubtrTrains);
allTrs = str2num(Trains.Titles);
[~,ia] = intersect(allTrs,sbtrTrs);

F = 1000; % 1ms overlap -> remove spikes

sp = round(Tsp*F/Fs); % decimate to 1ms
for k = 1:length(ia),
    st = round(Trains.Spikes{ia(k)}*F);
    [~,ix] = intersect(sp,st);
    sp(ix) = [];
    Tsp(ix) = [];
end
