function [E, WTarg] = WTEnergySpectrum(Trains, Tlims, FlagNormaliz)
persistent answer

Spikes = Trains.Spikes;
TrTitles = Trains.Titles;
[nTrs,nT] = size(TrTitles);
if isempty(answer)
    answer = {TrTitles(1,:),'auto','[0.125,32]','3'};
end
TrTT = reshape([TrTitles ','.*ones(nTrs,1)]',1,nTrs*(nT+1));
TrTT(end) = [];
answer = inputdlg({['Spike train (available:' TrTT ')'],'Sampling rate (Hz):',...
    'Frequency range (Hz):','Power orders'},...
    'Parameters for Wavelet Transform',1,answer);
if isempty(answer), return; end
chan = find(strcmp(strtrim(cellstr(TrTitles)),strtrim(answer{1}))==1);
if isempty(chan), errordlg('No such train!','error','modal'); return; end
if strcmp(answer{2},'auto')
    Fs = 2000/diff(Tlims);
else
    Fs = str2num(answer{2});
end
Frange = str2num(answer{3}); % frequency range (Hz)
Psc = str2num(answer{4}); % scale to plot power order
ko = 1;                    % morlet parameter
Dj = 0.0833/4;
nScls = round(log2(Frange(2)/Frange(1))/Dj);  % # of scales
a = 2.^((0:nScls)*Dj)/Frange(2);        % scales
b = Tlims(1):1/Fs:Tlims(2);        % time grid
% Wavelet transform
tic
f = warndlg('Working...', 'warning', 'modal');
WT = WT_Of_SpikeTrain(Spikes{chan}, ko, a, b, 1);
toc
% firing rate
FR = sum(Spikes{chan} >= b(1) & Spikes{chan} <= b(end))/(b(end) - b(1));
% Wavelet power
if strcmp(FlagNormaliz,'off')
    E = (abs(WT).^2)/(sqrt(pi)*ko*FR);
else
    F = 1./a;
    E = (F'*ones(1,size(WT,2))).*(abs(WT).^2)/(sqrt(pi)*ko*FR);
end
WTarg.p = a;
WTarg.t = b;
WTarg.MaxPowOrders = Psc;
WTarg.nTrn = chan;
close(f);