function g=gradordkde(X,s);

% Input: X -- mixtures, s=w*X -- one hidden source
% Output: gradient of entropy(w*X) w.r.t. w

[si,ord]=sort(s);
s=s(ord); % sort s
X=X(:,ord); % change the order of X as s

[m,n]=size(X);
ms=mean(s); sh=sqrt(mean(s.^2)-ms^2);
h=1/(sh*0.8*n^(-0.2)); % inverse scale for KDE

% calculate (clow,cup,slow,sup) and kde(s)
exps=exp(s*h);
slow=cumsum(exps);
sup=[0,cumsum(1./exps(n:-1:2))];
sup=sup(n:-1:1);
p=slow./exps+sup.*exps; % kde(s), omit scale 1/(2nh)

clow=cumsum(X.*repmat(exps,[m,1]),2);
cup=[zeros(m,1),cumsum(X(:,n:-1:2)./repmat(exps(n:-1:2),[m,1]),2)];
cup=cup(:,n:-1:1);

% calculate gradient w.r.t. p(w*X), omit scale 1/(2nh^2)
dp=clow./repmat(exps,[m,1])-X.*repmat(slow./exps,[m,1])...
    -repmat(exps,[m,1]).*cup+repmat(exps.*sup,[m,1]).*X;

% output gradient of entropy(w*X)
g=-mean(dp./repmat(p,[m,1]),2)*h;
return;