function [s, a] = wICAforLFPs(Y, Thr2)

L = length(Y);
Lev = min(10,floor(log2(L)));
[swa, swd] = SWTransform(Y, Lev);

id_artef = 1:L; id_signal = [];

Th = median(abs(swd(1,:)))/.67;
[~, s, a] = FitnesDenoise(Thr2*Th, Y, swa, swd, id_artef, id_signal);



% for c=1:nComp,
%     Y = icaEEG(c,:);
%     [id_artef, id_signal] = SplitArtefactsAndSignals(Y, Fs, ThrMult);
%     if isempty(id_artef),
%         disp(['The component #' num2str(c) ' passed unchaneged.']);
%         continue;
%     end

% Sign(c,:) = s;
% Artf(c,:) = a;


%     Thr1 = 2;
%     K1 = FitnesDenoise(Thr1*Th, Y, swa, swd, id_artef, id_signal) - Kthr;
%     Thr2 = 3;
%     if PrintFlag, fprintf('Calculating the component #%d\n', Comp(c)); end
%     for k = 1:20,
%         K2 = FitnesDenoise(Thr2*Th, Y, swa, swd, id_artef, id_signal) - Kthr;
%         ThrNew = Thr2 - K2*(Thr2 - Thr1)/(K2 - K1);
%         K1 = K2; Thr1 = Thr2;
%         Thr2 = ThrNew;
%         if PrintFlag, fprintf('*'); end
%         if abs(K2) < 0.005, break; end
%     end
%     if Thr2 < 3.6,
%         Thr2 = 3.6;
%         [K2, s] = FitnesDenoise(Thr2*Th, Y, swa, swd, id_artef, id_signal);
%         if PrintFlag
%             fprintf('. Too low threshold, set to default. Tolerance %f\n', abs(K2-Kthr));
%         end
%     else
%         [K2, s] = FitnesDenoise(Thr2*Th, Y, swa, swd, id_artef, id_signal);
%         if PrintFlag
%             fprintf('. Achieved tolerance %f\n', abs(K2-Kthr));
%         end
%     end
%     icaEEG(Comp(c),:) = s; 
%     opt(c) = Thr2;
% 
    
%     pause
    
    %     figure
%     subplot(2,1,1); hold off;
%     plot(id_signal,Y(id_signal),'k.'); hold on; plot(id_artef,Y(id_artef),'r.')
%     subplot(2,1,2); hold off
%     plot(Y); hold on; plot(a,'r');

% end



end

function [id_artef, id_signal] = SplitArtefactsAndSignals(X, Fs, ThrMult)
N = length(X);
L = round(Fs*0.1); 
Sig = median(abs(X)/0.6745);
Thr = ThrMult*Sig;
idx = find(abs(X) > Thr);
idx_ext = zeros(1,length(idx)*(2*L+1));
for k=1:length(idx),
    idx_ext((2*L+1)*(k-1)+1:(2*L+1)*k) = (idx(k)-L:idx(k)+L);
end
id_signal = setdiff((1:N), idx_ext);
id_artef  = setdiff((1:N), id_signal);
end


function [swa, swd] = SWTransform(X, Lev)
nx = length(X);
nX = 2^ceil(log2(nx));
if nX ~= nx, % extend to 2^L length if needed
    if nx/2 ~= ceil(nx/2),
        dN = nX - nx - 1;
    else
        dN = nX - nx;
    end
    X = wextend('1D', 'per', X, dN, 'r');
end
% wavelet transform
[swa, swd] = swt(X, Lev, 'db1');
end

function [KK, s, a] = FitnesDenoise(thld, X, swa, swd, id_a, id_s)
N = length(X);
swd_Den = (abs(swd) > thld).*swd;
% inverse transform
a = iswt(swa, swd_Den, 'db1');

% truncation (if needed)
a = a(1:N);
s = X - a;
Cs=corrcoef(X(id_s), s(id_s));
Ca=corrcoef(X(id_a), a(id_a));
KK = Ca(1,2)/Cs(1,2);
end



